#!/bin/sh
##############################################################################
#
#  Dolby Laboratories.
#  All rights reserved.
#
#  Redistribution in source or binary forms, with or without
#  modification, are NOT permitted.
#
#    Dolby Laboratories
#    1275 Market Street
#    San Francisco, CA 94103-1410 USA
#    Tel: +1-415-558-0200
#    Fax: +1-415-645-4000
#
# - version 1.0.0: ngoub, June 04, 2020
# - version 1.0.1: jferr, July 27, 2020
# - version 1.0.2: hgall, September 01, 2020
# - version 1.0.3: ngoub, September 09, 2020
# - version 1.0.4: hgall, September 24, 2020
#
##############################################################################

# Include package library
. ./pkg_lib.sh

# Include global variables
. ./variables.sh

# Include custom functions
. ./functions.sh

#
# main()
#

##########################################################################
#                                                                        #
#  INFORMATION                                                           #
#  -----------                                                           #
#                                                                        #
#  - The library will be included during the generation of this package  #
#  - To see all functions you can use in install.sh with this library:   #
#    pkg_gen.sh --show-functions                                         #
#    Or Open the WebGUI: http://packgen/pkgs/functions.php               #
#                                                                        #
##########################################################################

# Clear screen and Print installation header
print_installation_header

# Process the file ./pre-install.list
process_pre_install_list

# Process the file ./install.list
process_install_list

# Process the file ./post-install.list
process_post_install_list

# Print installation success
print_installation_success

exit 0

