#!/bin/sh
##############################################################################
#
#  PACKAGE COMMON LIBRARY
#  ----------------------
#
#  Dolby Laboratories.
#  All rights reserved.
#
#  Redistribution in source or binary forms, with or without
#  modification, are NOT permitted.
#
# - version 1.0.0:   smanenti, December  16, 2012
# - version 1.1.0:   smanenti, January   28, 2013
# - version 1.2.0:   smanenti, January   29, 2013
# - version 1.3.0:   smanenti, February  01, 2013
# - version 1.4.0:   smanenti, February  06, 2013
# - version 1.5.0:   smanenti, February  17, 2013
# - version 1.6.0:   smanenti, March     26, 2013
# - version 1.6.1:   smanenti, March     28, 2013
# - version 1.6.2:   smanenti, March     29, 2013
# - version 1.7.0:   smanenti, April     02, 2013
# - version 1.7.1:   smanenti, April     10, 2013
# - version 1.8.0:   smanenti, April     16, 2013
# - version 1.8.1:   smanenti, April     24, 2013
# - version 1.8.2:   smanenti, April     29, 2013
# - version 1.8.3:   smanenti, April     30, 2013
# - version 1.9.0:   smanenti, June      05, 2013
# - version 1.10.0:  smanenti, June      11, 2013
# - version 1.11.0:  smanenti, June      18, 2013
# - version 1.12.0:  smanenti, June      21, 2013
# - version 1.13.0:  smanenti, June      24, 2013
# - version 1.14.0:  smanenti, June      26, 2013
# - version 1.15.0:  smanenti, July      01, 2013
# - version 1.15.1:  smanenti, July      02, 2013
# - version 1.16.0:  smanenti, July      09, 2013
# - version 1.17.0:  smanenti, July      11, 2013
# - version 1.18.0:  smanenti, July      30, 2013
# - version 1.19.0:  smanenti, August    20, 2013
# - version 1.20.0:  smanenti, September 02, 2013
# - version 1.20.1:  smanenti, November  27, 2013
# - version 1.20.2:  smanenti, December  17, 2013
# - version 1.21.0:  smanenti, February  14, 2014
# - version 1.22.0:  smanenti, Februray  18, 2014
# - version 1.22.1:  smanenti, February  19, 2014
# - version 1.22.2:  smanenti, March     06, 2014
# - version 1.23.0:  smanenti, May       22, 2014
# - version 1.23.1:  smanenti, July      22, 2014
# - version 1.23.2:  smanenti, August    11, 2014
# - version 1.23.4:  smanenti, September 04, 2014
# - version 1.24.0:  smanenti, January   20, 2015
# - version 1.25.0:  smanenti, April     02, 2015
# - version 1.25.1:  smanenti, April     03, 2015
# - version 1.26.0:  smanenti, April     08, 2015
# - version 1.27.0:  smanenti, July      06, 2015
# - version 1.27.1:  smanenti, September 08, 2015
# - version 1.28.0:  smanenti+bvincent, September 29, 2015
# - version 1.28.1:  smanenti+bvincent, September 30, 2015
# - version 1.28.2:  smanenti+bvincent, September 30, 2015
# - version 1.28.3:  smanenti, October   01, 2015
# - version 1.28.4:  smanenti, February  01, 2016
# - version 1.28.5:  smanenti, February  10, 2016
# - version 1.29.0:  smanenti, March,    02, 2016
# - version 1.30.0:  smanenti, March,    31, 2016
# - version 1.31.0:  smanenti, August,   04, 2016
# - version 1.32.0:  smanenti, December  07, 2016
# - version 1.33.0:  smanenti, February  08, 2017
# - version 1.33.1:  smanenti, February  27, 2017
# - version 1.34.0:  smanenti, March     01, 2017
# - version 1.34.1:  smanenti, March     06, 2017
# - version 1.34.2:  smanenti, March     15, 2017
# - version 1.35.0:  smanenti, December  20, 2017
# - version 1.36.0:  smanenti, December  26, 2017
# - version 1.37.0:  smanenti, December  27, 2017
# - version 1.37.1:  smanenti, December  28, 2017
# - version 1.37.2:  smanenti, January   18, 2018
# - version 1.37.3:  smanenti, May       24, 2018
# - version 1.38.0:  smanenti, February  26, 2019
# - version 1.38.1:  smanenti, December  05, 2019
# - version 1.38.2:  smanenti, January   01, 2020
# - version 1.38.3:  smanenti, February  28, 2020
# - version 1.39.0:  smanenti, June      23, 2020
# - version 1.40.0:  smanenti, September 09  2020
#
##############################################################################

#
# Package library for: DCP2000, IMS1000, IMS2000, IMS3000, LE-100, NP-100, NP4000
# WARNING: If you modify this library, do not forget to notify Engineering
#          Because this library is now included from SW >= 2.7.1
#


#
# Variables for the package
# LOGTAG is automatically sets when generating signed package
# PACKAGE_NAME is automatically sets when generating signed package
# PACKAGE_VERSION is automatically sets when generating signed package
# DONE: used by function print_installation_success
#
LOGFILE="/doremi/log/update.log"
LOGTAG="dcp2000_ims2_sw_hotfix_accumulated_updates_2.8.30-1.0.4"
PACKAGE_NAME="sw_hotfix_accumulated_updates_2.8.30"
PACKAGE_VERSION="1.0.4"
DONE=1

#
# Variable of the system files and directories
#
FILE_BUNDLE_VER_COMP="/doremi/etc/bundle_versions_compatibility.txt"

#
# Variables for bundle
#
BUNDLE_INFO_PATH="/doremi/opt/pkgs/bundle"
BUNDLE_VERSION_FILE="/doremi/etc/bundle_version"
BUNDLE_NAME_FILE="/doremi/etc/bundle_name"
BUNDLE_STATE_UNKNOWN=-1
BUNDLE_STATE_INSTALLED=0
BUNDLE_STATE_INSTALLED_PARTIAL=1
BUNDLE_STATE_UNINSTALLED=2
BUNDLE_STATE_UNINSTALLED_PARTIAL=3


#
# Variables for colors
#
SETCOLOR_SUCCESS="echo -en \\033[1;32m"
SETCOLOR_FAILURE="echo -en \\033[1;31m"
SETCOLOR_WARNING="echo -en \\033[1;33m"
SETCOLOR_NORMAL="echo -en \\033[0;39m"


#
# Variables for function get_board_type
#
BOARD_UNKNOWN="unknown board"
BOARD_DOLPHIN_REVB="Dolphin RevB"
BOARD_DOLPHIN_10="Dolphin 1.0"
BOARD_DOLPHIN_12_LOWCAP="Dolphin 1.2 LowCap"
BOARD_DOLPHIN_12_FULLCAP="Dolphin 1.2 FullCap"
BOARD_CERTAINTY="Certainty"
BOARD_CLARITY="Clarity"


#
# Variables for function get_platform_type
#
PLATFORM_UNKNOWN="unknown"
PLATFORM_DCP2000="DCP2000"
PLATFORM_IMS1000="IMS1000"
PLATFORM_IMS2000="IMS2000"
PLATFORM_IMS3000="IMS3000"
PLATFORM_LE100="LE-100"
PLATFORM_NP100="NP-100"
PLATFORM_NP4000="NP4000"
PLATFORM_STREAMIT="StreamIt"
PLATFORM_S430_10="s430-10"


#
# Variables for function get_archive_type
#
ARCHIVE_UNKNOWN="unknown archive"
ARCHIVE_TAR="tar archive"
ARCHIVE_TARGZ="targz archive"
ARCHIVE_ZIP="zip archive"


#
# Variables for functions print_<..>
#
isStatusPrinted=0
nbMessagePrinted=0


#
# Variables for function set_rootfs
#
DEFAULT_PACKAGE_ROOTFS="rootfs"
PACKAGE_ROOTFS="${DEFAULT_PACKAGE_ROOTFS}"

#
# Variables for the backup
#
PATH_BACKUP_PKG_TOOL="/doremi/tmp/package_generator/backup_$$"

#
# Move cursor to RES_COL
# Returns: nothing
#
justify_right(){
  RES_COL=60
  echo -en \\033[${RES_COL}G
}


#
# log(string message)
# log(string message, string padding)
# Print a line of log in the file $LOGFILE
# If padding is sets, add the pattern before the log
# Return code: always 0
#   Eg: log "something that I want to log"         will log: something that I want to log
#   Eg: log "${myVar}" "\\t"                        will log your variable $myVar, and will add '\\t' before each log lines
#
log(){
  local MSG="$1"
  local PADDING="$2"

  # Just a sanity check...
  if [ "$(echo "${PADDING}" | wc -c)" -ge 8 ]; then
    PADDING="\t"
  fi

  # Write log line by line
  while read line; do
    echo -e "[$(date)]: ${LOGTAG}: ${PADDING}${line}" >> "${LOGFILE}"
  done << EOF
${MSG}
EOF

  return 0
}


#
# print_status
# Print the status on screen
#
print_status(){
  local STATUS="$1"
  local SETCOLOR="$2"

  nbMessagePrinted=$(( ${nbMessagePrinted} - 1 ))

  if [ "${isStatusPrinted}" -eq 1 ]; then
    return
  fi

  echo -n "["
  ${SETCOLOR}
  echo -n "${STATUS}"
  ${SETCOLOR_NORMAL}
  echo "]"

  isStatusPrinted=1
}


#
# print_failure()
# Print [FAILURE]
# Return code: nothing
#
print_failure(){
  print_status "FAILURE" "${SETCOLOR_FAILURE}"
}


#
# print_success()
# Print [SUCCESS]
# Return code: nothing
#
print_success(){
  print_status "SUCCESS" "${SETCOLOR_SUCCESS}"
}


#
# print_warning()
# Print [WARNING]
# Return code: nothing
#
print_warning(){
  print_status "WARNING" "${SETCOLOR_WARNING}"
}


#
# die(string message)
# Print an error then exit 127
# This function will also call: remount_rootfs_ro, delete_all_backup
# Return code: nothing
#   Eg: die Unsupported system
#
die(){
  local LOG="$*"

  # Remount rootfs to read-only
  # But do not die on failure: avoid loop die...
  remount_rootfs_ro 1

  # Delete all backup for this install
  delete_all_backup

  print_failure

  for i in $(seq 0 ${nbMessagePrinted}); do
    echo -n "  "
  done

  ${SETCOLOR_FAILURE}
  if [ "${LOG}" != "" ]; then
    echo "  ${LOG}"
  fi
  echo
  echo "Installation failed"
  echo
  ${SETCOLOR_NORMAL}

  # Log the installation failure in update.log
  if [ "${LOG}" != "" ]; then
    log "ERROR: $*"
  fi
  log "Installation failed"

  exit 127
}


#
# print_installation_header()
# Return code: nothing
#
print_installation_header(){
  clear
  echo
  echo "Installing ${LOGTAG}"
  echo
}


#
# print_uninstallation_header()
# Return code: nothing
#
print_uninstallation_header(){
  clear
  echo
  echo "Uninstalling ${LOGTAG}"
  echo
}


#
# print_installation_success()
# This function will also call: delete_all_backup, remount_rootfs_ro
# Return code: 0
#
print_installation_success(){
  local IS_UNINSTALL="$1"
  local MSG=""
  local returnCode=0

  # Delete all backup for this install
  delete_all_backup

  # Remount to read-only if its not the case
  remount_rootfs_ro
  returnCode=$?

  # If the return code is different than 2, it means some paritition were NOT in read-only
  # It means user forgot to revert the read-only before the end of the package installation (typically in post-install.list)
  if [ "${returnCode}" != "2" ]; then
    log "WARNING: partitions automatically remounted to read-only"
  fi

  if [ "${DONE}" -eq 0 ]; then
    MSG="No issue found on the system"
  else
    if [ "${IS_UNINSTALL}" == "1" ]; then
      MSG="Uninstallation successful"
    else
      MSG="Installation successful"
    fi
  fi

  ${SETCOLOR_SUCCESS}
  echo
  echo "${MSG}"
  echo
  ${SETCOLOR_NORMAL}

  # Log the installation success in update.log
  log "${MSG}"

  return 0
}


#
# print_uninstallation_success()
# This function will call the function print_installation_success
# Return code: nothing
#
print_uninstallation_success(){
  print_installation_success "1"
}


#
# remount_rootfs_rw()
# remount_rootfs_rw(boolean do_not_die_on_failure)
# Remount rootfs and /boot to read-write and die on failure (if set)
# WARNING: the system will be automatically remounted to read-only at the end of the installation, whatever the status (success or failure).
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: remount_rootfs_rw    (will die on failure)
#   Eg: remount_rootfs_rw 1  (will NOT die on failure)
#
remount_rootfs_rw(){
  local DO_NOT_DIE_ON_FAILURE="$1"
  local MESSAGE=""
  local isError=0

  # for s430-10 platform, there is no such thing as switching a partition from ro to rw
  if [ "$(get_platform_type)" == "${PLATFORM_S430_10}" ]; then
    return 0
  fi

  # Check if partitions are not already mounted in RW
  if is_read_write_fs / && is_read_write_fs /boot; then
    return 0
  fi

  if ! mount -o remount,rw / > /dev/null 2>&1; then
    isError=1
    MESSAGE="Failed to remount rootfs to read-write"
  elif ! mount -o remount,rw /boot > /dev/null 2>&1; then
    isError=1
    MESSAGE="Failed to remount /boot to read-write"
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DO_NOT_DIE_ON_FAILURE}" == "1" ]; then
      log "WARNING: ${MESSAGE}"
    else
      die "${MESSAGE}"
    fi
  fi

  return ${isError}
}


#
# remount_rootfs_ro()
# remount_rootfs_ro(boolean do_not_die_on_failure)
# Remount rootfs and /boot to read-only and die on failure (if set)
# Return code: 0 on success
# Return code: 1 on failure
# Return code: 2 if the partition were already in RO
#   Eg: remount_rootfs_ro    (will die on failure)
#   Eg: remount_rootfs_ro 1  (will NOT die on failure)
#
remount_rootfs_ro(){
  local DO_NOT_DIE_ON_FAILURE="$1"
  local MESSAGE=""
  local isError=0

  # for s430-10 platform, there is no such thing as switching a partition from rw to ro
  if [ "$(get_platform_type)" == "${PLATFORM_S430_10}" ]; then
    return 0
  fi

  # Flush file system buffers
  flush_buffers

  # Check if partitions are not already mounted in RO
  if ! is_read_write_fs / && ! is_read_write_fs /boot; then
    return 2
  fi

  if ! mount -o remount,ro / > /dev/null 2>&1; then
    isError=1
    MESSAGE="Failed to remount rootfs to read-only"
  elif ! mount -o remount,ro /boot > /dev/null 2>&1; then
    isError=1
    MESSAGE="Failed to remount /boot to read-only"
  fi

  if [ "${isError}" -ne 0 ]; then
    # If we are going to reboot, do not die (it is not necessary to abort the installation for that)
    if test -f /tmp/.update_require_reboot; then
      log "WARNING: ${MESSAGE} (not fatal: a reboot of the system is scheduled)"
    elif [ "${DO_NOT_DIE_ON_FAILURE}" == "1" ]; then
      log "WARNING: ${MESSAGE} (reboot the system to fix)"
    else
      die "${MESSAGE}"
    fi
  fi

  return ${isError}
}

#
# is_execution_bit_sets(string chmod)
# Return a boolean depending if the execution bit of the given chmod is sets
# Return code: 1 if the execution bit of the given chmod is sets, else returns 0
#   Eg: is_execution_bit_sets 0644   (will return 0)
#   Eg: is_execution_bit_sets 0744   (will return 1)
#   Eg: is_execution_bit_sets 0441   (will return 1)
#
is_execution_bit_sets(){
  local CHMOD="$1"
  local binary=""

  # Only get the latest 3 digits of the CHMOD
  CHMOD=$(echo -n "${CHMOD}" | tail -c 3)

  # Check each permission of the CHMOD
  for char in $(echo "${CHMOD}" | sed -e 's/\(.\)/\1\n/g'); do
    binary=$(echo "obase=2; ${char}" | bc)

    # Now, check if the last bit is 1: executable sets
    if [ "$(echo -n "${binary}" | tail -c 1)" == "1" ]; then
      return 0
    fi
  done

  return 1
}


#
# ver2num(string version)
# Convert a version string x.x.x-b into a number so it can be easily compared to another version string
# Return code: nothing
#   Eg: ver2num 2.4.0-0
#
ver2num(){
  if [ "$1" == "" ]; then
    echo ""
  else
    echo "$1" | awk -F '[^0-9]+' '{print $1*256*65536+$2*65536+$3*256+$4}' 2> /dev/null
  fi
}


#
# is_software_version_in_range(string sw_min, string sw_max, boolean sw_min_included, boolean sw_max_included)
# is_software_version_in_range(string sw_allowed)
# Check current software version with min and max and return 1 on failure; 0 on success
# Return code: 1 on failure
# Return code: 0 on success
#   Eg: is_software_version_in_range "2.0.10-0" "2.2.0-0" 1 0   (return 1 if SW is < 2.0.10-0 or if SW >= 2.2.0-0)
#   Eg: is_software_version_in_range "2.0.10-0" "" 1 0          (return 1 if SW is < 2.0.10-0)
#   Eg: is_software_version_in_range "" "2.2.0-0" 1 0           (return 1 if SW >= 2.2.0-0)
#   Eg: is_software_version_in_range "2.0.10-0"                 (return 1 SW is not 2.0.10-0)
#   Eg: is_software_version_in_range "2.0.x"                    (return 1 if SW is not 2.0.x)
#
is_software_version_in_range() {
  local SOFTVER="$(get_software_version)"
  local SOFTMIN="$1"
  local SOFTMAX="$2"
  local SOFTMIN_INCLUDED="$3"
  local SOFTMAX_INCLUDED="$4"
  local SOFTVER_NUM="$(ver2num ${SOFTVER})"
  local SOFTMIN_NUM="$(ver2num ${SOFTMIN})"
  local SOFTMAX_NUM="$(ver2num ${SOFTMAX})"
  local isError=0

  # Format include SW
  if [ "${SOFTMIN_INCLUDED}" == "1" ]; then
    SOFTMIN_INCLUDED="-lt"
  else
    SOFTMIN_INCLUDED="-le"
  fi
  if [ "${SOFTMAX_INCLUDED}" == "1" ]; then
    SOFTMAX_INCLUDED="-gt"
  else
    SOFTMAX_INCLUDED="-ge"
  fi

  # Test number of args
  if [ "$#" -eq 4 ]; then
    # Check SW min if required
    if [ "${SOFTMIN}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMIN_INCLUDED} "${SOFTMIN_NUM}" ]; then
      isError=1
    fi

    # Check SW max if required
    if [ "${SOFTMAX}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMAX_INCLUDED} "${SOFTMAX_NUM}" ]; then
      isError=1
    fi
  elif [ "$#" -eq 1 ]; then
    # Check SW 2.0.x
    if echo "${SOFTMIN}" | grep -q "\.x$"; then
      SOFTMIN=$(echo "${SOFTMIN}" | sed -e "s/x$//g")
      if ! echo "${SOFTVER}" | grep -q "^${SOFTMIN}"; then
        isError=1
      fi
    # Check SW 2.0.10
    elif [ "${SOFTVER_NUM}" -ne "${SOFTMIN_NUM}" ]; then
      isError=1
    fi
  else
    die "Unable to check the software version: wrong arguments"
  fi

  return ${isError}
}


#
# is_firmware_version_in_range(string fw_min, string fw_max, boolean fw_min_included, boolean fw_max_included)
# is_firmware_version_in_range(string fw_allowed)
# Check current firmware version with min and max and return 1 on failure; 0 on success
# Return code: 1 on failure
# Return code: 0 on success
#   Eg: is_firmware_version_in_range "1.0.10-0" "1.2.0-0" 1 0   (return 1 if FW is < 1.0.10-0 or if FW >= 1.2.0-0)
#   Eg: is_firmware_version_in_range "1.0.10-0" "" 1 0          (return 1 if FW is < 1.0.10-0)
#   Eg: is_firmware_version_in_range "" "1.2.0-0" 1 0           (return 1 if FW >= 1.2.0-0)
#   Eg: is_firmware_version_in_range "1.0.10-0"                 (return 1 FW is not 1.0.10-0)
#   Eg: is_firmware_version_in_range "1.0.x"                    (return 1 if FW is not 1.0.x)
#
is_firmware_version_in_range() {
  local SOFTVER="$(get_firmware_version)"
  local SOFTMIN="$1"
  local SOFTMAX="$2"
  local SOFTMIN_INCLUDED="$3"
  local SOFTMAX_INCLUDED="$4"
  local SOFTVER_NUM="$(ver2num ${SOFTVER})"
  local SOFTMIN_NUM="$(ver2num ${SOFTMIN})"
  local SOFTMAX_NUM="$(ver2num ${SOFTMAX})"
  local isError=0

  # Format include SW
  if [ "${SOFTMIN_INCLUDED}" == "1" ]; then
    SOFTMIN_INCLUDED="-lt"
  else
    SOFTMIN_INCLUDED="-le"
  fi
  if [ "${SOFTMAX_INCLUDED}" == "1" ]; then
    SOFTMAX_INCLUDED="-gt"
  else
    SOFTMAX_INCLUDED="-ge"
  fi

  # Test number of args
  if [ "$#" -eq 4 ]; then
    # Check SW min if required
    if [ "${SOFTMIN}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMIN_INCLUDED} "${SOFTMIN_NUM}" ]; then
      isError=1
    fi

    # Check SW max if required
    if [ "${SOFTMAX}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMAX_INCLUDED} "${SOFTMAX_NUM}" ]; then
      isError=1
    fi
  elif [ "$#" -eq 1 ]; then
    # Check SW 2.0.x
    if echo "${SOFTMIN}" | grep -q "\.x$"; then
      SOFTMIN=$(echo "${SOFTMIN}" | sed -e "s/x$//g")
      if ! echo "${SOFTVER}" | grep -q "^${SOFTMIN}"; then
        isError=1
      fi
    # Check SW 2.0.10
    elif [ "${SOFTVER_NUM}" -ne "${SOFTMIN_NUM}" ]; then
      isError=1
    fi
  else
    die "Unable to check the firmware version: wrong arguments"
  fi

  return ${isError}
}


#
# is_security_manager_version_in_range(string sm_min, string sm_max, boolean sm_min_included, boolean sm_max_included)
# is_security_manager_version_in_range(string sm_allowed)
# Check current Security Manager version with min and max and return 1 on failure; 0 on success
# Return code: 1 on failure
# Return code: 0 on success
#   Eg: is_security_manager_version_in_range "1.0.10-0" "1.2.0-0" 1 0   (return 1 if SM is < 1.0.10-0 or if SM >= 1.2.0-0)
#   Eg: is_security_manager_version_in_range "1.0.10-0" "" 1 0          (return 1 if SM is < 1.0.10-0)
#   Eg: is_security_manager_version_in_range "" "1.2.0-0" 1 0           (return 1 if SM >= 1.2.0-0)
#   Eg: is_security_manager_version_in_range "1.0.10-0"                 (return 1 SM is not 1.0.10-0)
#   Eg: is_security_manager_version_in_range "1.0.x"                    (return 1 if SM is not 1.0.x)
#
is_security_manager_version_in_range() {
  local SOFTVER="$(get_security_manager_version)"
  local SOFTMIN="$1"
  local SOFTMAX="$2"
  local SOFTMIN_INCLUDED="$3"
  local SOFTMAX_INCLUDED="$4"
  local SOFTVER_NUM="$(ver2num ${SOFTVER})"
  local SOFTMIN_NUM="$(ver2num ${SOFTMIN})"
  local SOFTMAX_NUM="$(ver2num ${SOFTMAX})"
  local isError=0

  # Format include SW
  if [ "${SOFTMIN_INCLUDED}" == "1" ]; then
    SOFTMIN_INCLUDED="-lt"
  else
    SOFTMIN_INCLUDED="-le"
  fi
  if [ "${SOFTMAX_INCLUDED}" == "1" ]; then
    SOFTMAX_INCLUDED="-gt"
  else
    SOFTMAX_INCLUDED="-ge"
  fi

  # Test number of args
  if [ "$#" -eq 4 ]; then
    # Check SW min if required
    if [ "${SOFTMIN}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMIN_INCLUDED} "${SOFTMIN_NUM}" ]; then
      isError=1
    fi

    # Check SW max if required
    if [ "${SOFTMAX}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMAX_INCLUDED} "${SOFTMAX_NUM}" ]; then
      isError=1
    fi
  elif [ "$#" -eq 1 ]; then
    # Check SW 2.0.x
    if echo "${SOFTMIN}" | grep -q "\.x$"; then
      SOFTMIN=$(echo "${SOFTMIN}" | sed -e "s/x$//g")
      if ! echo "${SOFTVER}" | grep -q "^${SOFTMIN}"; then
        isError=1
      fi
    # Check SW 2.0.10
    elif [ "${SOFTVER_NUM}" -ne "${SOFTMIN_NUM}" ]; then
      isError=1
    fi
  else
    die "Unable to check the Security Manager version: wrong arguments"
  fi

  return ${isError}
}


#
# update_release_md5(string path_bin)
# update_release_md5(string path_bin, boolean do_not_create_md5sum_if_missing)
# Update the release md5sum of a file
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: update_release_md5 /doremi/bin/odeticsd.out     (will add or update the md5sum)
#   Eg: update_release_md5 /doremi/bin/odeticsd.out 0   (will add or update the md5sum)
#   Eg: update_release_md5 /doremi/bin/odeticsd.out 1   (will only update the md5sum if it exists)
#
update_release_md5(){
  local BINARY="$1"
  local DO_NOT_CREATE_IF_MISSING="$2"
  local RELEASE_MD5="/doremi/etc/release.md5"
  local LOG=""

  if ! test -w "${RELEASE_MD5}"; then
    log "update_release_md5(): Failed to update md5sum of '${BINARY}' (${RELEASE_MD5} does not exist or cannot be written)"
    return 1
  elif ! test -f "${BINARY}"; then
    log "update_release_md5(): Failed to update md5sum of '${BINARY}' (no such file)"
    return 1
  elif grep -q " ${BINARY}$" "${RELEASE_MD5}"; then
    local oldmd5=$(grep " ${BINARY}$" "${RELEASE_MD5}" | cut -d ' ' -f1 | tr -d [:space:])
    local newmd5=$(md5sum "${BINARY}" | cut -d ' ' -f1 | tr -d [:space:])

    if [ "${oldmd5}" == "" ] || [ "${newmd5}" == "" ] ; then
      log "update_release_md5(): Failed to update md5sum of '${BINARY}' (empty value was returned)"
      return 1
    elif ! LOG=$(sed -u -i -e "s|${oldmd5}  ${BINARY}$|${newmd5}  ${BINARY}|" "${RELEASE_MD5}" 2>&1); then
      log "update_release_md5(): Failed to update md5sum of '${BINARY}' (failed to replace old value by new value)"
      log "${LOG}" "\t"
      return 1
    fi
  elif [ "${DO_NOT_CREATE_IF_MISSING}" == "1" ]; then
    return 0
  elif ! md5sum "${BINARY}" >> "${RELEASE_MD5}"; then
    log "update_release_md5(): Failed to add md5sum of '${BINARY}' (error while writting in ${RELEASE_MD5})"
    return 1
  fi

  return 0
}

#
# delete_release_md5(string path_pattern)
# Delete all entries of the release md5sum file, that matches the given <path_pattern>
# WARNING: USE THIS FUNCTION WITH CAUTION, SINCE IT IS USED TO REPORT MD5SUM FAILURES
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: delete_release_md5 /doremi/bin/odeticsd.out	(remove the entry /doremi/bin/odeticsd.out from the release md5sum file)
#   Eg: delete_release_md5 /doremi/www/web/		(remove all entries /doremi/www/web/ from the release md5sum file)
#
delete_release_md5(){
  local PATH_PATTERN="$1"
  local RELEASE_MD5="/doremi/etc/release.md5"
  local LOG=""

  if ! test -w "${RELEASE_MD5}"; then
    log "delete_release_md5(): Failed to delete md5sum of '${PATH_PATTERN}' (${RELEASE_MD5} does not exist or cannot be written)"
    return 1
  elif [ "${PATH_PATTERN}" == "" ]; then
    log "delete_release_md5(): Failed to delete md5sum of '${PATH_PATTERN}' (empty value provided)"
    return 1
  elif ! echo "${PATH_PATTERN}" | grep -q "^\/"; then
    log "delete_release_md5(): Failed to delete md5sum of '${PATH_PATTERN}' (invalid path)"
    return 1
  elif grep -q " ${PATH_PATTERN}" "${RELEASE_MD5}"; then
    if ! LOG=$(sed -i -e "\|^[0-9a-zA-Z]*[ \t]*${PATH_PATTERN}.*$|d" "${RELEASE_MD5}" 2>&1); then
      log "delete_release_md5(): Failed to delete md5sum of '${PATH_PATTERN}' (error while trying to delete value)"
      log "${LOG}" "\t"
      return 1
    elif grep -q " ${PATH_PATTERN}" "${RELEASE_MD5}"; then
      log "delete_release_md5(): Failed to delete md5sum of '${PATH_PATTERN}' (value is still present in release MD5)"
      return 1
    fi
  fi

  return 0
}


#
# install_all_patches(boolean die_on_failure)
# Install all patches present inside the package in the folders: './patches/common/' (for ALL platforms) './patches/<platform>/' (platform specific)
# WARNING: if you add the folder './patches/<platform>/', the '<platform>' MUST be in the same format than the function 'get_platform_type', in LOWER CASE. ie: 'ims2000', 'ims3000'
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_all_patches 1   (will apply ALL patches inside './patches/common/' + './patches/<platform>/' (if present), and die on failure)
#   Eg: install_all_patches 0   (will apply ALL patches inside './patches/common/' + './patches/<platform>/' (if present), and do NOT die on failure)
#
install_all_patches(){
  local DIE_ON_FAILURE="$1"
  local PLATFORM=""
  local LOG=""
  local isError=0

  if ! PLATFORM=$(get_platform_type); then
    LOG="Unable to retrieve the platform type"
    isError=1
  elif ! test -d "./patches/"; then
    LOG="Patches folder is not found inside the package: './patches/'"
    isError=1
  else
    PLATFORM=$(echo "${PLATFORM}" | tr '[:upper:]' '[:lower:]')

    for path_folder_patches in "./patches/common/" "./patches/${PLATFORM}/"; do
      if ! test -e "${path_folder_patches}"; then
        continue
      fi

      log "Installing patches of: ${path_folder_patches} ..."

      while read file_patch; do
        log "Installing patch: ${file_patch}" "\t"
        install_patch "${file_patch}" "${DIE_ON_FAILURE}"
      done <<< "$(find ${path_folder_patches} -type f)"
    done
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to install all patches: ${LOG}"
    else
      log "Failed to install all patches: ${LOG} (ignoring failure)"
    fi
  fi

  return ${isError}
}



#
# install_patch(string file_patch, boolean die_on_failure)
# Install the given patch on the system if not already installed, and die on failure (if sets).
# The release md5 will be updated automatically
# WARNING: you must use relative path for the patch file, which is located in your package and NOT absolute path (starting with a '/')
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_patch  patches/common/001_my_patch  1    (will apply the patch, and die on failure)
#   Eg: install_patch  patches/dcp2000/023_my_patch 0    (will apply the patch, and do NOT die on failure)
#
install_patch(){
  local FILE_PATCH="$1"
  local DIE_ON_FAILURE="$2"
  local LOG=""
  local isError=0

  # Sanity check
  if ! test -r "${FILE_PATCH}"; then
    LOG="The patch file is not found or cannot be read: ${FILE_PATCH}"
    isError=1
  elif patch -R -p0 -s -f --dry-run < "${FILE_PATCH}" &> /dev/null; then
    # Check if patch is NOT already applied
    log "Ignoring already applied patch: '${FILE_PATCH}'"
    return 0
  elif ! LOG=$(patch -p0 < "${FILE_PATCH}" 2>&1); then
    isError=1
  else
    # Update md5, if it exists
    local FILENAME_IN_PATCH=$(grep "^+++" "${FILE_PATCH}" | sed -u -e "s/^+++ *//g" | sed -u -e 's/[ \t]*[1-9][0-9][0-9][0-9]-[0-9][0-9]-.*//g')
    if ! test -e "${FILENAME_IN_PATCH}"; then
      LOG="Unable to update release md5sum after applying patch (patched file not found on the system: '${FILENAME_IN_PATCH}')"
      isError=1
    elif ! update_release_md5 "${FILENAME_IN_PATCH}" 1; then
      LOG="Unable to update release md5 after applying patch (failed to update release md5 of file '${FILENAME_IN_PATCH}')"
      isError=1
    fi
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to apply patch '${FILE_PATCH}': ${LOG}"
    else
      log "Failed to apply patch '${FILE_PATCH}': ${LOG} (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# install_file(string path_bin, string owner, string group, string mode, integer update_md5, boolean die_on_failure)
# Install a binary and update the release md5, and die on failure (if sets)
# WARNING: the binary, in your package, MUST be in: rootfs/doremi/bin/odeticsd.out
# WARNING: if you have more than one rootfs, call the function set_rootfs before
# WARNING: the argument update_md5 can have 3 values: 0 (do not update), 1 (update), 2 (update only if needed)
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_file /doremi/bin/odeticsd.out  root  admin  0755  1  1   (will install the file, update the release md5, and die on failure)
#   Eg: install_file /doremi/bin/odeticsd.out  root  admin  0755  2  1   (will install the file, update the release md5 ONLY if needed, and die on failure)
#
install_file(){
  local BIN_DEST="$1"
  local BIN_SOURCE="${PACKAGE_ROOTFS}${BIN_DEST}"
  local OWNER="$2"
  local GROUP="$3"
  local MODE="$4"
  local UPDATE_MD5="$5"
  local DIE_ON_FAILURE="$6"
  local PARENT_PATH=$(dirname "${BIN_DEST}")
  local ERROR=0

  if ! test -e "${BIN_SOURCE}"; then
    ERROR=1
  elif ! mkdir -p "${PARENT_PATH}" > /dev/null 2>&1; then
    ERROR=1
  elif ! yes | /bin/cp --no-dereference --remove-destination "${BIN_SOURCE}" "${BIN_DEST}" > /dev/null 2>&1; then
    ERROR=1
  elif ! chown ${OWNER}:${GROUP} "${BIN_DEST}" > /dev/null 2>&1; then
    ERROR=1
  elif ! chmod ${MODE} "${BIN_DEST}" > /dev/null 2>&1; then
    ERROR=1
  elif ! cmp --quiet "${BIN_SOURCE}" "${BIN_DEST}" > /dev/null 2>&1; then
    ERROR=1
  elif [ "${UPDATE_MD5}" -eq 1 ]; then
    if ! update_release_md5 "${BIN_DEST}" 0; then
      ERROR=1
    fi
  elif [ "${UPDATE_MD5}" -eq 2 ]; then
    if ! update_release_md5 "${BIN_DEST}" 1; then
      ERROR=1
    fi
  fi

  if [ "${ERROR}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to install '${BIN_DEST}'"
    else
      log "Failed to install '${BIN_DEST}' (ignoring failure)"
    fi
  fi

  return "${ERROR}"
}


#
# install_all_files(string path_directory, string owner, string group, string mode, integer update_md5, boolean die_on_failure)
# Install all files and binaries found on the given folder (in rootfs), and apply same owner, group, and mode.
# This function will die on the first failure, if sets.
# WARNING: the argument update_md5 can have 3 values: 0 (do not update), 1 (update), 2 (update only if needed)
# WARNING: due to security restriction on this function, all CHMOD with execution bit sets will be REFUSED
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_all_files /doremi/etc/  root  admin  0644  1  1   (will install all files, update the release md5, and die on failure)
#   Eg: install_all_files /doremi/etc/  root  admin  0644  2  1   (will install all files, update the release md5 ONLY if needed, and die on failure)
#   Eg: install_all_files /doremi/bin/  root  admin  0755  1  1   (will DIE with an error due to security restriction on the CHMOD)
#
install_all_files(){
  local PATH_DEST="$1"
  local PATH_SOURCE="${PACKAGE_ROOTFS}${PATH_DEST}"
  local OWNER="$2"
  local GROUP="$3"
  local MODE="$4"
  local UPDATE_MD5="$5"
  local DIE_ON_FAILURE="$6"
  local ERROR=0

  # Check if the execution bit of the chmod is sets.
  # If it is the case, die (for security reasons). Cf email thread: pkgtool security flaw
  # Instead, R&D shall use the function install_file.
  if is_execution_bit_sets "${MODE}"; then
    die "install_all_files(): mode '${MODE}' is not allowed (security restriction)"
    return 1
  fi

  # Check if the source exists
  if test -d "${PATH_SOURCE}"; then
    for file in $(find "${PATH_SOURCE}" -type f); do
      file=$(echo "${file}" | sed -e "s/^${PACKAGE_ROOTFS}\//\//g")

      if ! install_file "${file}" "${OWNER}" "${GROUP}" "${MODE}" "${UPDATE_MD5}" "${DIE_ON_FAILURE}"; then
        ERROR=1
      fi
    done
  else
    log "install_all_files() failure: directory missing in package: ${PATH_SOURCE}"
    ERROR=1
  fi

  # Die in case install_file() did not die
  if [ "${ERROR}" != "0" ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failure to install all files of '${PATH_DEST}'"
    else
      log "Failure to install all files of '${PATH_DEST}' (ignoring failure)"
    fi
  fi

  return "${ERROR}"
}


#
# is_debian()
# is_debian(string version)
# Is a debian system. If called with an argument, it will also check the debian version
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: is_debian 4.x
#   Eg: is_debian 3.1
#   Eg: is_debian
#
is_debian(){
  local VER_TO_CHECK="$1"

  if [ "${VER_TO_CHECK}" == "" ]; then
    if ! test -e /etc/debian_version; then
      return 1
    fi
  else
    VER_TO_CHECK=$(echo "${VER_TO_CHECK}" | sed -e "s/x//g")

    if ! grep -q "^${VER_TO_CHECK}" /etc/debian_version 2> /dev/null; then
      return 1
    fi
  fi

  return 0
}


#
# get_debian_version()
# get_debian_version(boolean convert_to_integer)
# Return the debian version (major) of the system (3, 4, 5, 6 ...)
# Return code: 0 on success
# Return code: 1 on failure
#  Eg: get_debian_version     (will return something like: 2.4.4-0)
#  Eg: get_debian_version 1   (will return something like: 33817600)
#
get_debian_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "debian version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# get_firmware_version()
# get_firmware_version(boolean convert_to_integer)
# Return the current firmware version of the system
# Return code: 0 on success
# Return code: 1 or more on failure
#  Eg: get_firmware_version     (will return something like: 2.4.4-0)
#  Eg: get_firmware_version 1   (will return something like: 33817600)
#
get_firmware_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "fw version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# get_software_version()
# get_software_version(boolean convert_to_integer)
# Return the current software version of the system
# Return code: 0 on success
# Return code: 1 or more on failure
#  Eg: get_software_version     (will return something like: 2.4.4-0)
#  Eg: get_software_version 1   (will return something like: 33817600)
#
get_software_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "sw version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# get_security_manager_version()
# get_security_manager_version(boolean convert_to_integer)
# Return the current Security Manager version of the system
# Return code: 0 on success
# Return code: 1 or more on failure
#  Eg: get_security_manager_version     (will return something like: 6.0.4-0)
#  Eg: get_security_manager_version 1   (will return something like: 33817600)
#
get_security_manager_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "sm version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# get_webgui_version
# get_webgui_version(boolean convert_to_integer)
# Return the current WebGUI version of the system (if installed)
# Return code: 0 on success
# Return code: 1 or more on failure or if the WebGUI is not installed
#  Eg: get_webgui_version     (will return something like: 1.1.5)
#  Eg: get_webgui_version 1   (will return something like: 33817600)
#
get_webgui_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "webgui version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# get_goldmaster_version()
# get_goldmaster_version(boolean convert_to_integer)
# Return the current GoldMaster version of the system
# Return code: 0 on success
# Return code: 1 or more on failure to retrieve the value
#  Eg: get_goldmaster_version     (will return something like: 1.1.0)
#  Eg: get_goldmaster_version 1   (will return something like: 33817600)
#
get_goldmaster_version(){
  local CONVERT_TO_INTERGER="$1"

  get_system_information "goldmaster version" "${CONVERT_TO_INTERGER}"

  return $?
}


#
# manage_service(string binary_name, string action)
# Manage a service with the given action.
# WARNING: if you want to start or stop a service, it is safer to use the function start_stop_service
# Return code: 0 on success
# Return code: 1 or more on failure
#   Eg: manage_service sshd reload       (reload the configuration of SSHD)
#   Eg: manage_service odeticsd restart  (restart the odeticsd daemon)
#
manage_service(){
  local SERVICE="$1"
  local MODE="$2"
  local LOG_ERROR=""
  local isError=0

  # Remove extension and path of the service (in case user adds it)
  SERVICE=$(basename "${SERVICE}" | sed -e "s/\..*$//g")

  if test -e /doremi/etc/init.d/${SERVICE}.init; then
    LOG_ERROR=$(sh /doremi/etc/init.d/${SERVICE}.init ${MODE} 2>&1)
    isError=$?
  elif test -e /doremi/etc/init.d/${SERVICE}; then
    LOG_ERROR=$(sh /doremi/etc/init.d/${SERVICE} ${MODE} 2>&1)
    isError=$?
  elif test -e /etc/init.d/${SERVICE}.init; then
    LOG_ERROR=$(sh /etc/init.d/${SERVICE}.init ${MODE} 2>&1)
    isError=$?
  elif test -e /etc/init.d/${SERVICE}; then
    LOG_ERROR=$(sh /etc/init.d/${SERVICE} ${MODE} 2>&1)
    isError=$?
  else
    isError=1
    LOG_ERROR="start / stop script has not been found on the system"
  fi

  if [ "${isError}" != "0" ] && [ "${LOG_ERROR}" != "" ]; then
    log "manage_service(): unable to ${MODE} the service '${SERVICE}':"
    log "${LOG_ERROR}" "\t"
  fi

  return ${isError}
}


#
# start_stop_service(string binary_name, string start_or_stop)
# start_stop_service(string binary_name, string start_or_stop, boolean start_only_if_stopped)
# Start or stop a service only if it's not already the case
# The option start_only_if_stopped allows you to start a service ONLY if it was stopped with this function
# Return code: 0 on success
# Return code: 1 or more on failure
#   Eg: start_stop_service odeticsd start    (force odeticsd to be started)
#   Eg: start_stop_service odeticsd stop     (force odeticsd to be stopped)
#   Eg: start_stop_service odeticsd start 1  (start odeticsd ONLY if it was stopped with this function)
#
SERVICES_STOPPED=""
start_stop_service(){
  local SERVICE="$1"
  local MODE="$2"
  local START_ONLY_IF_STOPPED="$3"
  local WAIT_GRACE=5
  local WAIT_GRACE_OK=0
  local isError=0

  if   [ "${SERVICE}" == "" ]; then
    die "Service not provided for function start_stop_service()"
  elif [ "${MODE}" != "start" ] && [ "${MODE}" != "stop" ]; then
    die "Wrong mode argument '${MODE}' for function start_stop_service()"
  fi

  # Remove extension and path of the service (in case user adds it)
  SERVICE=$(basename "${SERVICE}" | sed -e "s/\..*$//g")

  # Start or stop the service only if needed
  if [ "${MODE}" == "start" ]; then
    if [ "${START_ONLY_IF_STOPPED}" == "1" ]; then
      if ! echo "${SERVICES_STOPPED}" | grep -q "^${SERVICE}$"; then
        return 0
      fi
    fi
  fi

  # Start or stop the service
  manage_service "${SERVICE}" "${MODE}"
  isError=$?

  if [ "${isError}" != "0" ]; then
    log "WARNING: unable to ${MODE} the service '${SERVICE}' (error code: ${isError})"
  else
    # Check that the service is properly stopped / started (in case the manage_service function returns before)
    if   [ "${MODE}" == "stop" ] && is_process_running "${SERVICE}"; then
      WAIT_GRACE_OK=0
      for i in $(seq 1 ${WAIT_GRACE}); do
        if ! is_process_running "${SERVICE}"; then
          WAIT_GRACE_OK=1
          break
        fi
        sleep 1
      done

      if [ "${WAIT_GRACE_OK}" == "0" ]; then
        log "WARNING: Timeout while checking if the service '${SERVICE}' has been stopped (may still be running)"
      fi
    elif [ "${MODE}" == "start" ] && ! is_process_running "${SERVICE}"; then
      WAIT_GRACE_OK=0
      for i in $(seq 1 ${WAIT_GRACE}); do
        if is_process_running "${SERVICE}"; then
          WAIT_GRACE_OK=1
          break
        fi
        sleep 1
      done

      if [ "${WAIT_GRACE_OK}" == "0" ]; then
        log "WARNING: Timeout while checking if the service '${SERVICE}' has been started (may still be stopped)"
      fi
    fi
  fi

  # Is the service is successfully stopped, add it in the list of stopped services
  if [ "${MODE}" == "stop" ] && [ "${isError}" -eq 0 ]; then
    SERVICES_STOPPED="$(echo -e "${SERVICE}\n${SERVICES_STOPPED}")"
  fi

  return ${isError}
}


#
# start_stop_all_services(string start_stop)
# Start of stop all services and Doremi daemons
# Return code: 0
#   Eg: start_stop_all_services stop
#
start_stop_all_services(){
  local MODE="$1"
  local SERVICES="doremi-rc.d vsftpd"

  if [ "${MODE}" == "start" ]; then
    if test -c /dev/dolphin0; then
      if test -x /doremi/etc/init.d/doremi-hotplug.d; then
        /doremi/etc/init.d/doremi-hotplug.d ${MODE} > /dev/null 2>&1
      elif test -x /etc/init.d/doremi-hotplug.d; then
        /etc/init.d/doremi-hotplug.d ${MODE} > /dev/null 2>&1
      fi
    fi
  fi

  for service in ${SERVICES} ; do
    if test -x /doremi/etc/init.d/${service}; then
      /doremi/etc/init.d/${service} ${MODE} > /dev/null 2>&1
    elif test -x /etc/init.d/${service}; then
      /etc/init.d/${service} ${MODE} > /dev/null 2>&1
    fi
  done

  if test -x /etc/init.d/jailkit; then
    /etc/init.d/jailkit ${MODE} > /dev/null 2>&1
  fi

  if [ "${MODE}" == "stop" ]; then
    if test -c /dev/dolphin0; then
      if test -x /doremi/etc/init.d/doremi-hotplug.d; then
        /doremi/etc/init.d/doremi-hotplug.d ${MODE} > /dev/null 2>&1
      elif test -x /etc/init.d/doremi-hotplug.d; then
        /etc/init.d/doremi-hotplug.d ${MODE} > /dev/null 2>&1
      fi
    fi
  fi

  return 0
}


#
# process_install_list()
# Process the install.list file, if it exists or if it not empty
# This function will also print a messsage with a print_success at the end
# Return code: 0
#
process_install_list(){
  if ! test -f ./install.list; then
    return 0
  elif is_file_empty ./install.list 1; then
    return 0
  fi

  print_msg "Processing install list ..."
  chmod +x ./install.list
  . ./install.list
  print_success

  return 0
}


#
# process_pre_install_list()
# Process the pre-install.list file, if it exists or if it is not empty
# This function will also print a messsage with a print_success at the end
# Return code: 0
#
process_pre_install_list(){
  if ! test -f ./pre-install.list; then
    return 0
  elif is_file_empty ./pre-install.list 1; then
    return 0
  fi

  print_msg "Processing pre-install list ..."
  chmod +x ./pre-install.list
  . ./pre-install.list
  print_success

  return 0
}


#
# process_post_install_list()
# Process the post-install.list file, if it exists or if it is not empty
# This function will also print a messsage with a print_success at the end
# Return code: 0
#
process_post_install_list(){
  if ! test -f ./post-install.list; then
    return 0
  elif is_file_empty ./post-install.list 1; then
    return 0
  fi

  print_msg "Processing post-install list ..."
  chmod +x ./post-install.list
  . ./post-install.list
  print_success

  return 0
}


#
# is_process_running(string process_name)
# Return true is a process is running
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: is_process_running /doremi/bin/odeticsd.out or is_process_running odeticsd.out
#
is_process_running(){
  local PROCESS_NAME="$1"

  if ! pidof "${PROCESS_NAME}" > /dev/null 2>&1; then
    if ! pidof "${PROCESS_NAME}.out" > /dev/null 2>&1; then
      return 1
    fi
  fi

  return 0
}


#
# print_msg(string line)
# Print a line on screen during installation
# If more than one print_msg are called, it will be automatically indented until a print_<state> is called
# Return code: 0 (always)
#   Eg: print_msg Copying files ...
#
print_msg(){
  local MSG=""

  if [ "${isStatusPrinted}" -eq 0 ] && [ "${nbMessagePrinted}" -ge 1 ]; then
    echo
  fi

  for i in $(seq 0 ${nbMessagePrinted}); do
    MSG="${MSG}  "
  done
  MSG="${MSG}- $*"

  # Check if there is ... at the end
  if ! echo "${MSG}" | grep -q "\.\.\.[ \t]*$"; then
    MSG="${MSG} ..."
  fi

  # Print a message of 60 char, with a space at the end (in case the message is too long)
  echo -n "$(print_string "${MSG}" 0 59) "

  nbMessagePrinted=$(( ${nbMessagePrinted} + 1 ))
  isStatusPrinted=0

  return 0
}


#
# create_directory(string owner, string group, string perm, string path_directory)
# Create a directory with the owner and permissions
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: create_directory root admin 0755 /doremi/my_directory
#
create_directory(){
  local OWNER="$1"
  local GROUP="$2"
  local PERM="$3"
  local PATH_DIR="$4"

  if ! mkdir -p "${PATH_DIR}" > /dev/null 2>&1; then
    log "create_directory(): Failure to create directory '${PATH_DIR}'"
    return 1
  elif ! set_access "${OWNER}" "${GROUP}" "${PERM}" "${PATH_DIR}"; then
    log "create_directory(): Failure to set permission of directory '${PATH_DIR}' (${OWNER}:${GROUP} ${PERM})"
    return 1
  fi

  return 0
}


#
# create_file(string owner, string group, string perm, string path_file)
# create_file(string owner, string group, string perm, string path_file, string content)
# Create a file with the owner and permissions
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: create_file root admin 0644 /doremi/my_file           (will create an empty file)
#   Eg: create_file root admin 0644 /doremi/my_file "test\\n"  (will create a file with the value test, and a new line)
#
create_file(){
  local OWNER="$1"
  local GROUP="$2"
  local PERM="$3"
  local PATH_FILE="$4"
  local FILE_CONTENT="$5"

  if ! echo -n -e "${FILE_CONTENT}" > "${PATH_FILE}" 2> /dev/null; then
    log "create_file(): Failure to create file '${PATH_FILE}'"
    return 1
  elif ! set_access "${OWNER}" "${GROUP}" "${PERM}" "${PATH_FILE}"; then
    log "create_file(): Failure to create file '${PATH_FILE}' (${OWNER}:${GROUP} ${PERM})"
    return 1
  fi

  return 0
}


#
# set_access(string owner, string group, string perm, string path)
# Set access of the given directory or file
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: set_access root admin 0755 /doremi/bin/odeticsd.out
#
set_access(){
  local OWNER="$1"
  local GROUP="$2"
  local PERM="$3"
  local PATH_CONTENT="$4"

  if ! chown "${OWNER}.${GROUP}" "${PATH_CONTENT}" > /dev/null 2>&1; then
    log "set_access(): Failure to chown ${OWNER}.${GROUP} '${PATH_CONTENT}'"
    return 1
  elif ! chmod "${PERM}" "${PATH_CONTENT}" > /dev/null 2>&1; then
    log "set_access(): Failure to chmod ${PERM} '${PATH_CONTENT}'"
    return 1
  fi

  return 0
}


#
# set_access_for_all_directories(string owner, string group, string perm, string path)
# Set access for all directories found in the given path
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: set_access_for_all_directories root admin 0755 /doremi/bin/
#
set_access_for_all_directories(){
  local OWNER="$1"
  local GROUP="$2"
  local PERM="$3"
  local PATH_CONTENT="$4"
  local isError=0

  for dir in $(find "${PATH_CONTENT}" -type d); do
    if ! set_access "${OWNER}" "${GROUP}" "${PERM}" "${dir}"; then
      log "set_access_for_all_directories(): Failure to set permission of '${dir}' (${OWNER}:${GROUP} ${PERM})"
      isError=1
    fi
  done

  return ${isError}
}


#
# set_access_for_all_files(string owner, string group, string perm, string path)
# Set access for all files found in the given path
# Return code: 0 on success
# Return code: 1 on first failure
#   Eg: set_access_for_all_files root admin 0755 /doremi/bin/
#
set_access_for_all_files(){
  local OWNER="$1"
  local GROUP="$2"
  local PERM="$3"
  local PATH_CONTENT="$4"
  local isError=0

  for file in $(find "${PATH_CONTENT}" -type f); do
    if ! set_access "${OWNER}" "${GROUP}" "${PERM}" "${file}"; then
      log "set_access_for_all_files(): Failure to set permission of '${file}' (${OWNER}:${GROUP} ${PERM})"
      isError=1
    fi
  done

  return ${isError}
}


#
# check_debian_version(string sw_min, string sw_max, boolean sw_min_included, boolean sw_max_included)
# check_debian_version(string sw_allowed)
# Check current Debian version with min and max, and die on failure
# Return code: 0
#   Eg: check_debian_version "4" "6" 1 0   (die if Debian is < 4 or if Debian is >= 6)
#   Eg: check_debian_version "4" "" 1 0    (die if Debian is < 4)
#   Eg: check_debian_version "" "6" 1 0    (die if Debian is >= 6)
#   Eg: check_debian_version "4"           (die if Debian is not 4)
#
check_debian_version(){
  local SOFTVER="$(get_debian_version)"
  local SOFTMIN="$1"
  local SOFTMAX="$2"
  local SOFTMIN_INCLUDED="$3"
  local SOFTMAX_INCLUDED="$4"
  local SOFTVER_NUM="$(ver2num ${SOFTVER})"
  local SOFTMIN_NUM="$(ver2num ${SOFTMIN})"
  local SOFTMAX_NUM="$(ver2num ${SOFTMAX})"
  local isError=0

  if ! is_debian; then
    die "Unsupported system (only Debian is supported)"
  fi

  # Format include SW
  if [ "${SOFTMIN_INCLUDED}" == "1" ]; then
    SOFTMIN_INCLUDED="-lt"
  else
    SOFTMIN_INCLUDED="-le"
  fi
  if [ "${SOFTMAX_INCLUDED}" == "1" ]; then
    SOFTMAX_INCLUDED="-gt"
  else
    SOFTMAX_INCLUDED="-ge"
  fi

  # Test number of args
  if [ "$#" -eq 4 ]; then
    # Check Debian min if required
    if [ "${SOFTMIN}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMIN_INCLUDED} "${SOFTMIN_NUM}" ]; then
      isError=1
    fi

    # Check Debian max if required
    if [ "${SOFTMAX}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMAX_INCLUDED} "${SOFTMAX_NUM}" ]; then
      isError=1
    fi
  elif [ "$#" -eq 1 ]; then
    # Check Debian 4
    if [ "${SOFTVER_NUM}" -ne "${SOFTMIN_NUM}" ]; then
      isError=1
    fi
  else
    die "Unable to check Debian version: wrong arguments"
  fi

  if [ "${isError}" -ne 0 ]; then
    die "Current Debian version ${SOFTVER} is not supported"
  fi

  return 0
}

#
# check_security_manager_version(string sm_min, string sm_max, boolean sm_min_included, boolean sm_max_included)
# check_security_manager_version(string sm_allowed)
# Check current Security Manager version with min and max and die on failure
# Return code: 0
#   Eg: check_security_manager_version "6.0.10-0" "6.2.0-0" 1 0   (die if SM is < 6.0.10-0 or if SW >= 6.2.0-0)
#   Eg: check_security_manager_version "6.0.10-0" "" 1 0          (die if SM is < 6.0.10-0)
#   Eg: check_security_manager_version "" "6.2.0-0" 1 0           (die if SM >= 6.2.0-0)
#   Eg: check_security_manager_version "6.0.10-0"                 (die if SM is not 6.0.10-0)
#   Eg: check_security_manager_version "6.0.x"                    (die if SM is not 6.0.x)
#
check_security_manager_version(){
  local SOFTVER="$(get_security_manager_version)"

  if ! is_security_manager_version_in_range "$@"; then
    die "Current Security Manager version ${SOFTVER} is not supported"
  fi

  return 0
}


#
# check_software_version(string sw_min, string sw_max, boolean sw_min_included, boolean sw_max_included)
# check_software_version(string sw_allowed)
# Check current software version with min and max and die on failure
# Return code: 0
#   Eg: check_software_version "2.0.10-0" "2.2.0-0" 1 0   (die if SW is < 2.0.10-0 or if SW >= 2.2.0-0)
#   Eg: check_software_version "2.0.10-0" "" 1 0          (die if SW is < 2.0.10-0)
#   Eg: check_software_version "" "2.2.0-0" 1 0           (die if SW >= 2.2.0-0)
#   Eg: check_software_version "2.0.10-0"                 (die if SW is not 2.0.10-0)
#   Eg: check_software_version "2.0.x"                    (die if SW is not 2.0.x)
#
check_software_version(){
  local SOFTVER="$(get_software_version)"

  if ! is_software_version_in_range "$@"; then
    die "Current software version ${SOFTVER} is not supported"
  fi

  return 0
}


#
# check_firmware_version(string fw_min, string fw_max, boolean fw_min_included, boolean fw_max_included)
# check_firmware_version(string fw_allowed)
# Check current firmware version with min and max and die on failure
# Return code: 0
#   Eg: check_firmware_version "30.05-14" "30.05-23" 1 0   (die if FW is < 30.05-14 or if FW is >= 30.05-23)
#   Eg: check_firmware_version "30.05-14" "" 1 0           (die if FW is < 30.05-14)
#   Eg: check_firmware_version "" "30.05-23" 1 0           (die if FW is >= 30.05-23)
#   Eg: check_firmware_version "30.05-12"                  (die if FW is not 30.05-12)
#   Eg: check_firmware_version "30.x"                      (die if FW is not 30.x)
#
check_firmware_version(){
  local SOFTVER="$(get_firmware_version)"

  if ! is_firmware_version_in_range "$@"; then
    die "Current firmware version ${SOFTVER} is not supported"
  fi

  return 0
}


#
# check_bundle_version(string bundle_min, string bundle_max, boolean bundle_min_included, boolean bundle_max_included)
# check_bundle_version(string bundle_allowed)
# Check current bundle version with min and max and die on failure
# Return code: 0
#   Eg: check_bundle_version "0.8.0-0" "0.8.3" 1 0   (die if bundle is < 0.8.0-0 or if FW is >= 0.8.3)
#   Eg: check_bundle_version "0.8.0" "" 1 0          (die if bundle is < 0.8.0)
#   Eg: check_bundle_version "" "0.8.0" 1 0          (die if bundle is >= 0.8.0)
#   Eg: check_bundle_version "0.8.0"                 (die if bundle is not 0.8.0)
#   Eg: check_bundle_version "0.8.x"                 (die if bundle is not 0.8.x)
#
check_bundle_version(){
  local SOFTVER=$(get_system_information "bundle version")
  local SOFTMIN="$(echo $1 | sed -e 's/-/\./g')"
  local SOFTMAX="$(echo $2 | sed -e 's/-/\./g')"
  local SOFTMIN_INCLUDED="$3"
  local SOFTMAX_INCLUDED="$4"
  local SOFTVER_NUM="$(ver2num ${SOFTVER})"
  local SOFTMIN_NUM="$(ver2num ${SOFTMIN})"
  local SOFTMAX_NUM="$(ver2num ${SOFTMAX})"
  local isError=0

  # Format include SW
  if [ "${SOFTMIN_INCLUDED}" == "1" ]; then
    SOFTMIN_INCLUDED="-lt"
  else
    SOFTMIN_INCLUDED="-le"
  fi
  if [ "${SOFTMAX_INCLUDED}" == "1" ]; then
    SOFTMAX_INCLUDED="-gt"
  else
    SOFTMAX_INCLUDED="-ge"
  fi

  # Test number of args
  if [ "$#" -eq 4 ]; then
    # Check FW min if required
    if [ "${SOFTMIN}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMIN_INCLUDED} "${SOFTMIN_NUM}" ]; then
      isError=1
    fi

    # Check FW max if required
    if [ "${SOFTMAX}" != "" ] && [ "${SOFTVER_NUM}" ${SOFTMAX_INCLUDED} "${SOFTMAX_NUM}" ]; then
      isError=1
    fi
  elif [ "$#" -eq 1 ]; then
    # Check SW 30.x
    if echo "${SOFTMIN}" | grep -q "\.x$"; then
      SOFTMIN=$(echo "${SOFTMIN}" | sed -e "s/x$//g")
      if ! echo "${SOFTVER}" | grep -q "^${SOFTMIN}"; then
        isError=1
      fi
    # Check SW 30.05-23
    elif [ "${SOFTVER_NUM}" -ne "${SOFTMIN_NUM}" ]; then
      isError=1
    fi
  else
    die "Unable to check bundle version: wrong arguments"
  fi

  if [ "${isError}" -ne 0 ]; then
    die "Current bundle version ${SOFTVER} is not supported"
  fi

  return 0
}


#
# check_platform_type(platform platform_types_allowed)
# Check the platform type, and die if this platform is not allowed
# Cf. the function get_platform_type for available PLATFORM_
# Return code: 0
#   Eg: check_platform_type PLATFORM_LE100                      (die if platform is not PLATFORM_LE100)
#   Eg: check_platform_type PLATFORM_DCP2000 PLATFORM_IMS1000   (die if platform is not PLATFORM_DCP2000 or PLATFORM_IMS1000)
#
check_platform_type(){
  local PLATFORMS="$*"
  local current_platform_name="$(get_platform_type)"
  local isError=1

  for platform_allowed in ${PLATFORMS}; do
    # To be compatible with PPC /bin/sh interpreter, use following syntax to fetch
    # the value of the variable name stored in platform_allowed
    local platform_allowed_name="$(eval echo \$${platform_allowed})"

    if [ "${platform_allowed_name}" == "" ]; then
      die "Unable to check platform type: wrong arguments"
    elif [ "${current_platform_name}" == "${platform_allowed_name}" ]; then
      isError=0
      break
    fi
  done

  if [ "${isError}" -ne 0 ]; then
    die "Current platform ${current_platform_name} is not supported"
  fi

  return 0
}


#
# reboot_required()
# Inform the system that it must reboot once the package is installed
# Return code: 0 on success
# Return code: 1 on failure
#
reboot_required(){
  local LOG=""

  if ! LOG=$(touch /tmp/.update_require_reboot 2>&1); then
    log "reboot_required(): Failure to request reboot (${LOG})"
    return 1
  fi

  return 0
}


#
# create_link(string path_link, string path_target)
# Create a symbolic link
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: create_link /etc/apache2/sites-enabled/000-default  ../sites-available/default
#
create_link(){
  local PATH_LINK="$1"
  local PATH_TARGET="$2"
  local PARENT_PATH_LINK="$(dirname "${PATH_LINK}")"
  local isError=0

  if ! mkdir -p "${PARENT_PATH_LINK}" > /dev/null 2>&1; then
    log "create_link(): Failure to create parent directory of link (${PARENT_PATH_LINK})"
    isError=1
  elif ! ln -nsf "${PATH_TARGET}" "${PATH_LINK}" > /dev/null 2>&1; then
    log "create_link(): Failure to create symlink '${PATH_LINK}' to '${PATH_TARGET}'"
    isError=1
  fi

  return ${isError}
}


#
# get_init_script_links(string path_file_initd)
# get_init_script_links(string path_file_initd, string where_to_search)
# Get all init script links on the system (rc.d, standby.d, hotplug.d, rcS.d....) for the given init.d file.
# This can be used to know where a process is started (ie: rc.d, rcS, rc2.d, etc...).
# Return code: always 0
#   Eg: get_init_script_links /doremi/etc/init.d/odeticsd.init   (Can return a list: /doremi/etc/standby.d/20_odeticsd /doremi/etc/hotplug.d/20_odeticsd)
#   Eg: get_init_script_links ../init.d/odeticsd.init            (Same result as the exemple above)
#   Eg: get_init_script_links /etc/init.d/lighttpd /etc/rc3.d    (Will only return the list of init links into /etc/rc3.d for /etc/init.d/lighttpd. Thus, only /etc/rc3.d/S21lighttpd)
#
get_init_script_links(){
  local PATH_FILE_INITD="$1"
  local WHERE_TO_SEARCH="$2"

  # Format values: in case we did not provide place to search, default values.
  if [ "${WHERE_TO_SEARCH}" == "" ]; then
    WHERE_TO_SEARCH="/doremi/etc/ /etc/"
  fi

  # Get all the links of the init.d file.
  if echo "${PATH_FILE_INITD}" | grep -q "^\.\./"; then
    find ${WHERE_TO_SEARCH} -maxdepth 3 -lname "${PATH_FILE_INITD}" 2> /dev/null | grep -v "^${PATH_FILE_INITD}$"
  else
    find -L ${WHERE_TO_SEARCH} -maxdepth 3 -samefile "${PATH_FILE_INITD}" 2> /dev/null | grep -v "^${PATH_FILE_INITD}$"
  fi

  return 0
}


#
# delete_init_script_links(string path_file_initd)
# delete_init_script_links(string path_file_initd, string where_to_search)
# Delete all init script links found on the system.
# You can specify a directory to search (else, by default, will search everywhere), for example only into /doremi/etc/rc.d/.
# WARNING: BE VERY CAREFULL WITH THIS FUNCTION, AS YOU MAY DELETE ALL INIT SCRIPTS ON THE SYSTEM, RESULTING IN A BROKEN UNIT.
# Will die in case it fails to delete a link.
# Return code: always 0
#   Eg: delete_init_script_links /doremi/etc/init.d/odeticsd.init   (Deletes ALL init scripts found on the system for odeticsd, everywhere - CAUTION)
#   Eg: delete_init_script_links ../init.d/odeticsd.init            (Same as the example above)
#   Eg: delete_init_script_links /etc/init.d/lighttpd /etc/rc3.d    (Deletes ALL init scripts found for lighttpd, ONLY into /etc/rc3.d/)
#
delete_init_script_links(){
  local PATH_FILE_INITD="$1"
  local WHERE_TO_SEARCH="$2"
  local init_script_links=""
  local LOG=""

  for init_script_links in $(get_init_script_links "${PATH_FILE_INITD}" "${WHERE_TO_SEARCH}"); do
    # Double check if it is a link
    if test -L "${init_script_links}"; then
      if ! LOG=$(rm -f "${init_script_links}" 2>&1); then
        log "Unable to delete link: ${init_script_links}"
        log "${LOG}" "\t"
        die "Faile to delete init script link '${init_script_links}'"
      else
        log "Init script link deleted: ${init_script_links}"
      fi
    fi
  done

  return 0
}


#
# create_init_script_link(int priority, string file_name, string folder_name, int update_option, boolean die_on_failure)
# Create a symbolic link of an init script in /doremi/etc/<folder_name> and die on failure (if sets)
# The option 'update_option' can have the following values:
#   0: No update:     Do not create the link if it exists with the same priority
#   1: Force update:  Create the link even if it exists with the same priority (force update)
#   2: Update clean:  Create the link even if it exists + delete any other links (ensure to keep only one link of the script)
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: create_init_script_link 20 odeticsd rc.d 0 1    (Create the link /doremi/etc/rc.d/20_odeticsd --> ../init.d/odeticsd.init ONLY if it does NOT exist)
#   Eg: create_init_script_link 50 odeticsd rc.d 1 1    (Create the link /doremi/etc/rc.d/50_odeticsd --> ../init.d/odeticsd.init EVEN if it exists)
#   Eg: create_init_script_link 50 odeticsd rc.d 2 1    (Create the link /doremi/etc/rc.d/50_odeticsd --> ../init.d/odeticsd.init EVEN if it exists and REMOVE any other existing links)
#
create_init_script_link(){
  local PRIORITY="$1"
  local FILE_NAME="$2"
  local FOLDER_NAME="$3"
  local UPDATE_OPTION="$4"
  local DIE_ON_FAILURE="$5"
  local SOURCE="../init.d/${FILE_NAME}.init"
  local DEST="/doremi/etc/${FOLDER_NAME}/${PRIORITY}_${FILE_NAME}"
  local PARENT_PATH_DEST="$(dirname "${DEST}")"
  local isError=0

  if   [ "${UPDATE_OPTION}" == "0" ]; then
    # If the link alreay exist, do nothing.
    test -L "${DEST}" && return 0
  elif [ "${UPDATE_OPTION}" == "1" ]; then
    # If the link already exist, remove it.
    test -L "${DEST}" && rm -f "${DEST}"
  elif [ "${UPDATE_OPTION}" == "2" ]; then
    # If the link already exist, remove it
    test -L "${DEST}" && rm -f "${DEST}"

    # Now, search and delete any other link (ie: if they have different priority)
    delete_init_script_links "${SOURCE}" "${PARENT_PATH_DEST}"
  else
    die "create_init_script_link(): Invalid value '${UPDATE_OPTION}' for argument 'update_option'"
  fi

  if ! mkdir -p "${PARENT_PATH_DEST}" > /dev/null 2>&1; then
    isError=1
  elif ! ln -sf "${SOURCE}" "${DEST}" > /dev/null 2>&1; then
    isError=1
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to create symbolic link: ${DEST}"
    else
      log "Failed to create symbolic link: ${DEST} (ignoring failure)"
    fi
  fi

  return "${isError}"
}


#
# safe_delete_file(string file_path)
# Delete a file, only if it exist and die on failure
# WARNING: This function will also remove the md5sum entry of the file in /doremi/etc/release.md5
# Return code: 0
#   Eg: safe_delete_file /doremi/etc/init.d/99_whatever
#
safe_delete_file(){
  local FILE_PATH="$1"

  if [ -f "${FILE_PATH}" ] || [ -L "${FILE_PATH}" ]; then
    if ! rm -f "${FILE_PATH}" > /dev/null 2>&1; then
      die "Failed to delete file: ${FILE_PATH}"
    elif ! delete_release_md5 "${FILE_PATH}"; then
      die "Failed to remove release md5 of file: ${FILE_PATH}"
    fi
  fi

  return 0
}


#
# safe_delete_folder(string folder_path)
# Delete a directory, only if it exist and die on failure
# WARNING: This function will also remove ALL md5sum entries of the directory in /doremi/etc/release.md5
# Return code: 0
#   Eg: safe_delete_folder /doremi/etc/init.d
#
safe_delete_folder(){
  local DIR_PATH="$1"

  if [ -d "${DIR_PATH}" ]; then
    if ! rm -fr "${DIR_PATH}" > /dev/null 2>&1; then
      die "Failed to delete folder: ${DIR_PATH}"
    elif ! delete_release_md5 "${DIR_PATH}"; then
      die "Failed to remove all release md5 of directory: ${DIR_PATH}"
    fi
  fi

  return 0
}


#
# check_directory_exists(string folder_path)
# Check if a directory exists and die on failure
# Return code: 0
#   Eg: check_directory_exists /doremi/etc
#
check_directory_exists(){
  local PATH_DIR="$1"

  if ! test -d "${PATH_DIR}"; then
    die "Directory does not exist: ${PATH_DIR}"
  fi

  return 0
}


#
# check_file_exists(string file_path)
# Check if a file (not a link) exists and die on failure
# Return code: 0
#   Eg: check_file_exists /doremi/etc/netmap.xml
#
check_file_exists(){
  local PATH_FILE="$1"

  if ! test -f "${PATH_FILE}"; then
    die "File does not exist: ${PATH_FILE}"
  fi

  return 0
}


#
# check_sym_link_exists(string sym_link_path)
# Check if a symbolic link exists and die on failure
# Return code: 0
#   Eg: check_sym_link_exists /doremi/etc/init.d/20_odeticsd
#
check_sym_link_exists(){
  local PATH_LINK="$1"

  if ! test -L "${PATH_LINK}"; then
    die "Symbolic link does not exist: ${PATH_LINK}"
  fi

  return 0
}


#
# rwdo(string cmdline)
# Remount / to RW, then execute the cmdline, then remount / to RO
# Return code: the exit code of the command
#   Eg: rwdo rm -f /etc/my_file
#
rwdo(){
  local exitCode=0

  remount_rootfs_rw
  $*
  exitCode=$?
  remount_rootfs_ro

  return "${exitCode}"
}


#
# get_total_memory_installed()
# Get the total amount of memory (RAM) installed on the system, in MB
# Return code: nothing
#
get_total_memory_installed(){
  local MEM_IN_BYTES=$(cat /proc/meminfo 2> /dev/null | grep MemTotal | cut -d : -f 2  | tr -d [:alpha:] | tr -d [:space:])
  local MEM_IN_MB=$(( ${MEM_IN_BYTES} / 1024 ))

  echo ${MEM_IN_MB}

  return 0
}


#
# install_package(string package_name)
# install_package(string package_name, boolean die_on_failure)
# Install a package located at the root directory of the package
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_package dcp2000_patch-2.4.3-0.pkg    (will not die on failure)
#   Eg: install_package dcp2000_patch-2.4.3-0.pkg 1  (will die on failure)
#
install_package(){
  local PKG_NAME="$1"
  local DIE_ON_FAILURE="$2"
  local PWD_OLD="$(pwd)"
  local PKG_INSTALL_PATH="${PWD_OLD}/pkg_install"
  local PKG_PATH="${PWD_OLD}/${PKG_NAME}"
  local isError=0

  if ! test -e "${PKG_INSTALL_PATH}"; then
    isError=1
  elif ! test -e "${PKG_PATH}"; then
    isError=1
  elif ! /bin/sh "${PKG_INSTALL_PATH}" "${PKG_PATH}"; then
    isError=1
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to install package: ${PKG_NAME}"
    else
      log "Failed to install package: ${PKG_NAME} (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# is_raid_mounted(boolean check_data, boolean check_opt)
# Check if /data and/or /opt are mounted (md0 and md1, or on NAS in case of Disk Less)
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: is_raid_mounted 1 0
#
is_raid_mounted(){
  local CHECK_DATA="$1"
  local CHECK_OPT="$2"
  local isError=0

  if [ "${CHECK_DATA}" == "1" ]; then
    if ! mount | grep " \/data " | grep -q -e "^\/dev\/md0" -e ":partition_data\/data"; then
      isError=1
    fi
  fi

  if [ "${CHECK_OPT}" == "1" ]; then
    if ! mount | grep " \/opt " | grep -q "^\/dev\/md1" -e ":partition_opt\/.*\/opt"; then
      isError=1
    fi
  fi

  return ${isError}
}


#
# is_webui_installed()
# Check if the Web UI is installed on the unit
# Return code: 0 if Web UI is installed
# Return code: 1 if Web UI is NOT installed
#   Eg: is_webui_installed
#
is_webui_installed() {
  local PATH_WEB="/doremi/www/web"

  if test -e "${PATH_WEB}/index.php" &&
     test -e "${PATH_WEB}/config.php"; then
    return 0
  fi

  return 1
}


#
# is_read_write_fs(string path_dir)
# Check if the given directory is located on a read-write file system
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: is_read_write_fs /data/maps/
#
is_read_write_fs(){
  local PATH_DIRECTORY="$1"
  local PATH_MOUNTED_ON=$(df "${PATH_DIRECTORY}" | tail -n 1 | sed -e "s|^.*/|/|g")

  if cat /proc/mounts | grep -v "^rootfs" | awk '{printf $2" "$4"\n"}' | grep -q "^${PATH_MOUNTED_ON} rw"; then
    return 0
  else
    return 1
  fi
}


#
# get_path_dolphin0()
# Get the path of the Dolphin0. Ie: /proc/driver/dolphin0 or /proc/dolphin0
# This function outputs nothing if the path is NOT found (ie: MediaBlock is disconnected)
# Return code: 0 on success
# Return code: 1 on failure
#
get_path_dolphin0(){
  if test -e /proc/driver/dolphin0; then
    echo "/proc/driver/dolphin0";
    return 0
  elif test -e /proc/dolphin0; then
    echo "/proc/dolphin0";
    return 0
  fi

  return 1
}


#
# get_board_type()
# Get the board type of the server (Dolphin 1.0, 1.2 FC, 1.2 LC, Clarity, Certainty...)
# This function can return:
#   - BOARD_UNKNOWN
#   - BOARD_DOLPHIN_REVB
#   - BOARD_DOLPHIN_10
#   - BOARD_DOLPHIN_12_LOWCAP
#   - BOARD_DOLPHIN_12_FULLCAP
#   - BOARD_CERTAINTY
#   - BOARD_CLARITY
# Return code: 0 on success
# Return code: 1 on failure
#
get_board_type(){
  local DOLPHIN0=""

  # Get the Dolphin path
  if ! DOLPHIN0=$(get_path_dolphin0); then
    echo "${BOARD_UNKNOWN}"
    return 1
  fi

  local mcore_cap=$(grep MCORE_CAP "${DOLPHIN0}" | awk '{print $2}')
  local fpga_cap=$(grep FPGA_CAP "${DOLPHIN0}" | awk '{print $2}')

  if test -z "${mcore_cap}"; then
    echo "${BOARD_UNKNOWN}"
    return 1
  elif test -z "${fpga_cap}"; then
    echo "${BOARD_UNKNOWN}"
    return 1
  fi

  mcore_cap=0x${mcore_cap}
  fpga_cap=0x${fpga_cap}

  if [ $(( (${fpga_cap} >> 23) & 1 )) -eq 1 ]; then
    echo "${BOARD_CERTAINTY}"
  elif [ $(( (${fpga_cap} >> 14) & 1 )) -eq 1 ]; then
    echo "${BOARD_CLARITY}"
  elif [ $(( (${mcore_cap} >> 29) & 1 )) -eq 1 ]; then
    echo "${BOARD_DOLPHIN_12_LOWCAP}"
  elif [ $(( (${mcore_cap} >> 30) & 1 )) -eq 1 ]; then
    echo "${BOARD_DOLPHIN_12_FULLCAP}"
  elif [ $(( (${fpga_cap} >> 1) & 1 )) -eq 1 ]; then
    echo "${BOARD_DOLPHIN_10}"
  else
    echo "${BOARD_DOLPHIN_REVB}"
  fi

  return 0
}


#
# exec_force(string cmd_line)
# Execute a command line and assume yes to all
# WARNING: use with caution !
# Return code: the exit code of the command
#   Eg: exec_force /doremi/sbin/mcsetup.out --raz-keyids
#
exec_force(){
  local CMD="$*"

  yes | ${CMD}

  return $?
}


#
# backup(string path_content_to_backup, boolean die_on_failure)
# Backup a file or a directory and die on failure (if sets)
# You can then restore this folder or file with the function restore
# WARNING: all backup will be deleted after the installation of the package (success or failure)
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: backup /doremi/www/web/ 0
#   Eg: backup /doremi/etc/macro.xml 1
#
backup(){
  local PATH_CONTENT_TO_BACKUP="$1"
  local DIE_ON_FAILURE="$2"
  local FILE_BACKUP="${PATH_BACKUP_PKG_TOOL}/backup.db"
  local isError=0

  if ! test -e "${PATH_CONTENT_TO_BACKUP}"; then
    isError=1
  elif ! mkdir -p "${PATH_BACKUP_PKG_TOOL}" > /dev/null 2>&1; then
    isError=1
  elif ! rm -fr "${PATH_BACKUP_PKG_TOOL}/${PATH_CONTENT_TO_BACKUP}" > /dev/null 2>&1; then
    isError=1
  elif ! yes | cp -a --preserve --parent "${PATH_CONTENT_TO_BACKUP}" "${PATH_BACKUP_PKG_TOOL}" > /dev/null 2>&1; then
    isError=1
  elif ! echo "${PATH_CONTENT_TO_BACKUP}" >> "${FILE_BACKUP}" 2> /dev/null; then
    isError=1
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to backup '${PATH_CONTENT_TO_BACKUP}'"
    else
      log "Failed to backup '${PATH_CONTENT_TO_BACKUP}' (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# restore(string path_content_to_restore, boolean die_on_failure)
# Restore a file or a directory that has been backuped before with the function backup and die on failure (if sets)
# You can restore all backuped files and folder at the same time, with the special value: all
# WARNING: if the content was NOT backuped, this function will exit with return code 0
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: restore /doremi/www/web/ 0
#   Eg: restore /doremi/etc/macro.xml 1
#   Eg: restore all 1
#
restore(){
  local PATH_CONTENT_TO_RESTORE="$1"
  local DIE_ON_FAILURE="$2"
  local FILE_BACKUP="${PATH_BACKUP_PKG_TOOL}/backup.db"
  local isError=0

  if ! test -f "${FILE_BACKUP}"; then
    # Do nothing, nothing was backuped
    return 0
  fi

  if [ "${PATH_CONTENT_TO_RESTORE}" == "all" ]; then
    PATH_CONTENT_TO_RESTORE=$(cat "${FILE_BACKUP}")
  fi

  for path_content in ${PATH_CONTENT_TO_RESTORE}; do
    local PATH_PARENT_CONTENT=$(dirname "${path_content}")

    if ! grep -q -e "^${path_content}$" -e "^${path_content}/$" "${FILE_BACKUP}"; then
      # Do nothing, the content was not backuped
      isError=0
    elif ! test -e "${PATH_BACKUP_PKG_TOOL}/${path_content}"; then
      isError=1
    elif ! mkdir -p "${PATH_PARENT_CONTENT}" > /dev/null 2>&1; then
      isError=1
    elif ! yes | cp -a --preserve "${PATH_BACKUP_PKG_TOOL}/${path_content}" "${PATH_PARENT_CONTENT}" > /dev/null 2>&1; then
      isError=1
    fi

    if [ "${isError}" -ne 0 ]; then
      if [ "${DIE_ON_FAILURE}" == "1" ]; then
        die "Failed to restore '${path_content}'"
      else
        log "Failed to restore '${path_content}' (ignoring failure)"
      fi
    fi
  done

  return ${isError}
}


#
# delete_all_backup()
# Delete all backup created with the function backup
# This function will be called when the installation of the package is finished
# Return code: 0 on success
# Return code: 1 on failure
#
delete_all_backup(){
  if ! test -d "${PATH_BACKUP_PKG_TOOL}"; then
    return 0
  elif ! rm -fr "${PATH_BACKUP_PKG_TOOL}" > /dev/null 2>&1; then
    log "delete_all_backup(): Failure to delete Package Generator backup"
    return 1
  else
    return 0
  fi
}


#
# print_string(string message, int start, int length)
# Print a string from start, with a specific length
# This is usefull to print a line with a fixed length
# Return code: nothing
#   Eg: print_string my_very_long_message_to_cut 0 12  (Will output: my_very_long)
#
print_string(){
  local STRING="$1"
  local START="$2"
  local LENGTH="$3"

  # Add spaces if the string is too small
  # For PPC /bin/sh we must avoid printf function, so build up the padding ourselves
  local PADSIZE=$(( ${LENGTH}-$(echo -n "${STRING}" | wc -c) ))
  for i in $(seq 1 ${PADSIZE}); do
    STRING="${STRING} "
  done

  # Cut the string
  # For PPC /bin/sh ${STRING:${START}:${LENGTH}} doesn work, so cut the string ourselves
  echo "${STRING}" | cut -b $(( ${START}+1 ))-$(( ${START}+${LENGTH} ))

  return 0
}


#
# install_archive(string archive, string path_destination, boolean die_on_failure)
# Install an archive stored in the package at the given destination and die on failure (if sets)
# WARNING: this function ONLY works for tar, targz and zip archives.
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: install_archive mypath/archive.tgz /doremi/etc/ 1
#
install_archive(){
  local FILE_ARCHIVE="$1"
  local PATH_DESTINATION="$2"
  local DIE_ON_FAILURE="$3"
  local ARCHIVE_TYPE=""
  local isError=0

  if ! test -f "${FILE_ARCHIVE}"; then
    isError=1
  elif ! ARCHIVE_TYPE=$(get_archive_type "${FILE_ARCHIVE}"); then
    isError=1
  elif ! mkdir -p "${PATH_DESTINATION}" > /dev/null 2>&1; then
    isError=1
  else
    if [ "${ARCHIVE_TYPE}" == "${ARCHIVE_TAR}" ]; then
      if ! tar xpf "${FILE_ARCHIVE}" -C "${PATH_DESTINATION}" > /dev/null 2>&1; then
        isError=1
      fi
    elif [ "${ARCHIVE_TYPE}" == "${ARCHIVE_TARGZ}" ]; then
      if ! tar zxpf "${FILE_ARCHIVE}" -C "${PATH_DESTINATION}" > /dev/null 2>&1; then
        isError=1
      fi
    elif [ "${ARCHIVE_TYPE}" == "${ARCHIVE_ZIP}" ]; then
      if ! unzip "${FILE_ARCHIVE}" -d "${PATH_DESTINATION}" > /dev/null 2>&1; then
        isError=1
      fi
    else
      isError=1
    fi
  fi

  if [ "${isError}" -ne 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "Failed to install archive '${FILE_ARCHIVE}'"
    else
      log "Failed to install archive '${FILE_ARCHIVE}' (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# get_archive_type(string archive)
# Get the archive type (targz, zip, tar...)
# This function can return:
#   - ARCHIVE_UNKNOWN
#   - ARCHIVE_TAR
#   - ARCHIVE_TARGZ
#   - ARCHIVE_ZIP
# Return code: 0 on success
# Return code: 1 on failure
#
get_archive_type(){
  local FILE_ARCHIVE="$1"

  if ! test -f "${FILE_ARCHIVE}"; then
    echo "${ARCHIVE_UNKNOWN}"
    return 1
  elif file "${FILE_ARCHIVE}" 2>&1 | grep -q -i "tar archive"; then
    echo "${ARCHIVE_TAR}"
  elif file "${FILE_ARCHIVE}" 2>&1 | grep -q -i "gzip compressed"; then
    echo "${ARCHIVE_TARGZ}"
  elif file "${FILE_ARCHIVE}" 2>&1 | grep -q -i "zip archive"; then
    echo "${ARCHIVE_ZIP}"
  else
    echo "${ARCHIVE_UNKNOWN}"
    return 1
  fi

  return 0
}


#
# get_serial_number()
# get_serial_number(boolean try_from_cache)
# Get the serial number of the machine
# This function can return the S/N (integer), or error (string)
# Return code: 0 on success
# Return code: 1 on failure
#  Eg: get_serial_number     (will return the S/N only if available)
#  Eg: get_serial_number 1   (will return the S/N if available, else the S/N of the cache)
#
get_serial_number(){
  local FROM_CACHE="$1"
  local DRMINFO="/doremi/bin/drminfo.out"
  local DRMINFO_OPTIONS=""
  local SN=""
  local isError=0

  if [ "${FROM_CACHE}" == "1" ]; then
    # First current S/N, then from cache
    DRMINFO_OPTIONS="-s -sc"
  else
    # Only current S/N
    DRMINFO_OPTIONS="-s"
  fi

  if ! test -x "${DRMINFO}"; then
    SN="error"
    isError=1
  else
    for options in ${DRMINFO_OPTIONS}; do
      if ! SN="$(${DRMINFO} ${options})"; then
        SN="error"
        isError=1
      elif echo "${SN}" | grep -q -i "missing"; then
        SN="error"
        isError=1
      elif echo "${SN}" | grep -q -i "[a-zA-Z]"; then
        SN="error"
        isError=1
      else
        isError=0
      fi

      # We found the S/N
      if [ "${isError}" == "0" ]; then
        break
      fi
    done
  fi

  # Return S/N or error
  echo "${SN}"

  return ${isError}
}


#
# get_system_information(string info_type)
# get_system_information(string info_type, boolean convert_to_integer)
# Get a system information
# This function can return the value you asked for, or missing, or empty
# The flag <convert_to_integer> will convert the value to an integer.
# All available info type are:
#   - Product Name
#   - Serial Number
#   - FW Version
#   - SW Version
#   - SM Version
#   - Watermark Video
#   - Watermark Audio
#   - Chassis Number
#   - Debian Version
#   - Web Version
#   - GoldMaster version
# Return code: 0 on success
# Return code: 1 or other on failure
#   Eg: get_system_information "serial number"		(will return something like '199000')
#   Eg: get_system_information "fw version" 0		(will return something like '1.1.2-3')
#   Eg: get_system_information "sm version" 1		(will return something like '12345'
#
get_system_information(){
  local INFO="$1"
  local CONVERT_TO_INT="$2"
  local DRMINFO="/doremi/bin/drminfo.out"
  local WEB_CONFIG="/doremi/www/web/config.php"
  local DEBIAN_FILE="/etc/debian_version"
  local GOLDMASTER_FILE="/etc/CF_version"
  local VALUE=""

  if ! test -x "${DRMINFO}"; then
    return 1
  fi

  if   echo "${INFO}" | grep -q -i "product name"; then
    VALUE=$("${DRMINFO}" -p)
  elif echo "${INFO}" | grep -q -i "serial number"; then
    VALUE=$("${DRMINFO}" -s)
  elif echo "${INFO}" | grep -q -i "fw version"; then
    VALUE=$("${DRMINFO}" -f)
  elif echo "${INFO}" | grep -q -i "sw version"; then
    if [ "$(get_platform_type)" == "${PLATFORM_S430_10}" ]; then
      VALUE=$("${DRMINFO}" -t | cut -d : -f 2)
    else
      VALUE=$("${DRMINFO}" -r)
    fi
  elif echo "${INFO}" | grep -q -i "watermark video"; then
    VALUE=$("${DRMINFO}" -w)
  elif echo "${INFO}" | grep -q -i "watermark audio"; then
    VALUE=$("${DRMINFO}" -W)
  elif echo "${INFO}" | grep -q -i "sm version"; then
    VALUE=$("${DRMINFO}" -m)
  elif echo "${INFO}" | grep -q -i "chassis number"; then
    VALUE=$("${DRMINFO}" -C)
  elif echo "${INFO}" | grep -q -i "bundle"; then
    VALUE=$("${DRMINFO}" -b)
  elif echo "${INFO}" | grep -q -i "debian version"; then
    if test -r "${DEBIAN_FILE}"; then
      VALUE=$(cat "${DEBIAN_FILE}" | cut -d'.' -f1)
    fi
  elif echo "${INFO}" | grep -q -i -e "web version" -e "webgui version" -e "web gui version"; then
    if test -r "${WEB_CONFIG}"; then
      VALUE=$(grep -i "'version'" "${WEB_CONFIG}" | sed -e "s/^[ \t]*'version'[ \t]*=>[ \t]*'//g" | cut -d \' -f1)
    fi
  elif echo "${INFO}" | grep -q -i -e "goldmaster version" -e "gold master version"; then
    if test -r "${GOLDMASTER_FILE}"; then
      VALUE=$(cat "${GOLDMASTER_FILE}")
    fi
  else
    return 1
  fi

  if [ "${CONVERT_TO_INT}" == "1" ]; then
    ver2num "${VALUE}"
  else
    echo "${VALUE}"
  fi

  return 0
}


#
# is_in_rconce_at_boot()
# Return 0 if you are currently in rc.once and at boot, else return 1
# Return code: 0 on success
# Return code: 1 on failure
#
is_in_rconce_at_boot(){
  if [ "${RUNLEVEL}" == "S" ] && [ "${RC_ONCE}" == "1" ]; then
    return 0
  else
    return 1
  fi
}


#
# is_module_loaded(string module_name)
# Return 0 if the module is loaded, else return 1
# Return code: 0 on success
# Return code: 1 on failure
#
is_module_loaded(){
  local MODULE_NAME="$1"

  if ! lsmod 2>&1 | grep -q "^${MODULE_NAME} "; then
    return 1
  else
    return 0
  fi
}


#
# get_platform_type()
# Get the platform type of the server (IMS, DCP2000, LE100, ...)
# WARNING: If the file /etc/platform does not exist, I will return PLATFORM_DCP2000
# This function can output one of these bash variables:
#   - PLATFORM_UNKNOWN
#   - PLATFORM_DCP2000
#   - PLATFORM_IMS1000
#   - PLATFORM_IMS2000
#   - PLATFORM_IMS3000
#   - PLATFORM_LE100
#   - PLATFORM_NP100
#   - PLATFORM_NP4000
#   - PLATFORM_STREAMIT
#   - PLATFORM_S430_10
# Return code: 0 on success
# Return code: 1 on failure
#
get_platform_type(){
  local FILE_PLATFORM="/etc/platform"
  local PLATFORM=""

  # Try to find the platform
  if test -r "${FILE_PLATFORM}"; then
    PLATFORM=$(cat "${FILE_PLATFORM}" 2> /dev/null)
  else
    PLATFORM="dcp2000"
  fi

  # Format the platform
  if [ "${PLATFORM}" != "${PLATFORM_S430_10}" ]; then
    PLATFORM=$(echo "${PLATFORM}" | head -n 1 | tr '[:upper:]' '[:lower:]' | tr -d '[:punct:][:space:]')
  fi

  # Return the platform
  if   [ "${PLATFORM}" == "dcp2000" ]; then
    echo "${PLATFORM_DCP2000}"
  elif [ "${PLATFORM}" == "ims" ]; then
    echo "${PLATFORM_IMS1000}"
  elif [ "${PLATFORM}" == "ims2" ]; then
    echo "${PLATFORM_IMS2000}"
  elif [ "${PLATFORM}" == "ims3" ]; then
    echo "${PLATFORM_IMS3000}"
  elif [ "${PLATFORM}" == "le100" ]; then
    echo "${PLATFORM_LE100}"
  elif [ "${PLATFORM}" == "np100" ]; then
    echo "${PLATFORM_NP100}"
  elif [ "${PLATFORM}" == "np4000" ]; then
    echo "${PLATFORM_NP4000}"
  elif [ "${PLATFORM}" == "streamit" ]; then
    echo "${PLATFORM_STREAMIT}"
  elif [ "${PLATFORM}" == "s430-10" ] || [ "${PLATFORM}" == "r430-10" ]; then
    echo "${PLATFORM_S430_10}"
  else
    echo "${PLATFORM_UNKNOWN}"
    return 1
  fi

  return 0
}


#
# ingest_content(string path_content)
# Ingest a content CPL, KDM, DLM... using /doremi/bin/ingestc.out
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: ingest_content ./my_cpl/
#
ingest_content(){
  local PATH_CONTENT="$1"
  local INGESTC="/doremi/bin/ingestc.out"

  if ! test -x "${INGESTC}"; then
    log "ingest_content(): Failure to ingest content (${INGESTC} does not exist or cannot be executed)"
    return 1
  elif ! test -e "${PATH_CONTENT}"; then
    log "ingest_content(): Failure to ingest content (content does not exist: ${PATH_CONTENT})"
    return 1
  elif ! ${INGESTC} --read-only --incoming ${PATH_CONTENT} --monitor /data > /dev/null 2>&1; then
    return 1
  fi

  return 0
}


#
# get_md5sum(string path_file)
# Get the md5sum of a file
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: get_md5sum /doremi/bin/odeticsd.out
#
get_md5sum(){
  local PATH_FILE="$1"
  local MD5SUM=""

  if ! test -f "${PATH_FILE}"; then
    log "get_md5sum(): Failure to get md5sum of '${PATH_FILE}' (no such file)"
    return 1
  elif ! MD5SUM="$(md5sum "${PATH_FILE}" 2>&1)"; then
    log "get_md5sum(): Failure to get md5sum of '${PATH_FILE}' (${MD5SUM})"
    return 1
  elif [ "${MD5SUM}" == "" ]; then
    log "get_md5sum(): Failure to get md5sum of '${PATH_FILE}' (MD5SUM reported is empty)"
    return 1
  else
    echo "${MD5SUM}" | awk '{print $1}'
  fi

  return 0
}


#
# uninstall_linux_package(string package_name)
# Uninstall a Linux package, assuming yes to all questions
# WARNING: This function will remount the rootfs to read-write if needed
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: uninstall_linux_package rinetd
#
uninstall_linux_package(){
  local PACKAGE_NAME="$1"
  local IS_ROOTFS_REMOUNTED_RW=0
  local LOG=""
  local isError=0

  # Remount rootfs to read-write if needed
  if ! is_read_write_fs /; then
    remount_rootfs_rw
    IS_ROOTFS_REMOUNTED_RW=1
  fi

  # Uninstall package
  LOG=$(DEBIAN_FRONTEND=noninteractive exec_force dpkg --purge --force-remove-reinstreq "${PACKAGE_NAME}" 2>&1)
  isError=$?

  if [ "${isError}" != "0" ]; then
    log "Failure to uninstall Linux package: ${PACKAGE_NAME}"
    log "${LOG}" "\t"
  fi

  # Remount rootfs to read-only if needed
  if [ "${IS_ROOTFS_REMOUNTED_RW}" == "1" ]; then
    remount_rootfs_ro
  fi

  return ${isError}
}


#
# is_linux_package_installed(string package_name)
# is_linux_package_installed(string package_name, boolean check_version_installed)
# Check if a Linux package is installed on the unit or not.
# The <package_name> can be a Linux package name (ie: samba)
# or a .deb file in which you want to test if it is already installed or not.
# WARNING: This function will remount the rootfs to read-write if needed
# Return code: 0 if the Linux package is already installed without any issue
# Return code: 1 if the Linux package is not installed or partialy installed / uninstalled
#   Eg: is_linux_package_installed samba			(Checks if the package samba is installed, WHATEVER the version)
#   Eg: is_linux_package_installed /tmp/samba-common-bin.deb	(Checks if the package samba-common-bin is installed, WHATEVER the version of the .deb)
#   Eg: is_linux_package_installed /tmp/samba-common-bin.deb 1	(Checks if the package samba-common-bin is installed, MATCHING the version of the .deb)
#   Eg: is_linux_package_installed /tmp/samba-common-bin.deb 0	(Checks if the package samba-common-bin is installed, WHATEVER the version)
#
is_linux_package_installed(){
  local LINUX_PACKAGE="$1"
  local CHECK_VERSION_INSTALLED="$2"
  local LINUX_PACKAGE_INFOS=""
  local LINUX_PACKAGE_NAME="sw_hotfix_accumulated_updates_2.8.30"
  local LINUX_PACKAGE_VERSION="1.0.4"
  local IS_ROOTFS_REMOUNTED_RW=0
  local installInfos=""
  local installState=""
  local installVersion=""
  local isError=0

  # Sanity check
  if [ "${LINUX_PACKAGE}" == "" ]; then
    log "is_linux_package_installed(): Unable to check installation of package (value provided is empty)"
    return 1
  fi

  # Remount rootfs to read-write if needed
  if ! is_read_write_fs /; then
    remount_rootfs_rw
    IS_ROOTFS_REMOUNTED_RW=1
  fi

  # First, get the real Linux Package name + version in case we provided a .deb file
  if echo "${LINUX_PACKAGE}" | grep -i -q "\.deb$"; then
    # Get the package info from the deb file
    if LINUX_PACKAGE_INFOS=$(dpkg-deb --info "${LINUX_PACKAGE}" 2> /dev/null); then
      LINUX_PACKAGE_NAME=$(echo "${LINUX_PACKAGE_INFOS}" | grep 'Package: ' | cut -d ':' -f2- | tr -d ' ')
      LINUX_PACKAGE_VERSION=$(echo "${LINUX_PACKAGE_INFOS}" | grep 'Version: ' | cut -d ':' -f2- | tr -d ' ')
    else
      die "is_linux_package_installed(): Unable to get package information from the .deb file '${LINUX_PACKAGE}' (make sure your deb file is correct)"
    fi
  else
    # We provided directly the name of the Linux package to check (cannot check the version)
    LINUX_PACKAGE_NAME="${LINUX_PACKAGE}"
    LINUX_PACKAGE_VERSION="1.0.4"
  fi

  # Sanity checks: if we want to check the version of the package but version cannot be retrived,
  # This is an issue, as we cannot ensure the version installed
  if [ "${CHECK_VERSION_INSTALLED}" == "1" ] && [ "${LINUX_PACKAGE_VERSION}" == "" ]; then
    die "is_linux_package_installed(): Unable to check the version of '${LINUX_PACKAGE}' installed on the system (did not provide .deb file or cannot retrieve its version)"
  fi

  # Now, get the installation state on the unit
  if [ "${LINUX_PACKAGE_NAME}" != "" ]; then
    installInfos=$(dpkg -s "${LINUX_PACKAGE_NAME}" 2> /dev/null)
    installState=$(echo "${installInfos}" | grep 'Status: ' | cut -d ':' -f2- | tr -d ' ')
    installVersion=$(echo "${installInfos}" | grep 'Version: ' | cut -d ':' -f2- | tr -d ' ')
  fi

  # Check the installation state
  if [ "${installState}" == "installokinstalled" ]; then
    # Check the version installed if we have to
    if [ "${CHECK_VERSION_INSTALLED}" == "1" ] && [ "${LINUX_PACKAGE_VERSION}" != "${installVersion}" ]; then
      # Installed, but version missmatch
      isError=1
    else
      # Installed, and up to date (or we don't care of the version installed)
      isError=0
    fi
  else
    # Not installed, whatever version
    isError=1
  fi

  # Remount rootfs to read-only if needed
  if [ "${IS_ROOTFS_REMOUNTED_RW}" == "1" ]; then
    remount_rootfs_ro
  fi

  return ${isError}
}


#
# install_linux_package(string path_file_deb)
# install_linux_package(string path_file_deb, boolean only_if_not_installed)
# install_linux_package(string path_file_deb, boolean only_if_not_installed, boolean check_version_installed)
# Install a Linux package, assuming yes to all questions
# WARNING: This function will remount the rootfs to read-write if needed
# Return code: 0 on success
# Return code: 1 or more on failure
#   Eg: install_linux_package my_linux_package.deb	(will install the package, whatever if it is already installed)
#   Eg: install_linux_package my_linux_package.deb 1	(will install the package, ONLY if it is NOT installed on unit, or partially installed, WHATEVER the version)
#   Eg: install_linux_package my_linux_package.deb 1 1	(will install the package, ONLY if it is NOT installed on unit, or partially installed, MATCHING the version)
#
install_linux_package(){
  local LINUX_PACKAGE="$1"
  local ONLY_IF_NOT_INSTALLED="$2"
  local CHECK_VERSION_INSTALLED="$3"
  local PACKAGE_NAME=$(basename "${LINUX_PACKAGE}")
  local IS_ROOTFS_REMOUNTED_RW=0
  local INSTALL_PACKAGE=0
  local LOG=""
  local isError=0

  # Remount rootfs to read-write if needed
  if ! is_read_write_fs /; then
    remount_rootfs_rw
    IS_ROOTFS_REMOUNTED_RW=1
  fi

  # Optional argument to install only if not already installed
  INSTALL_PACKAGE=1
  if [ "${ONLY_IF_NOT_INSTALLED}" == "1" ]; then
    if is_linux_package_installed "${LINUX_PACKAGE}" "${CHECK_VERSION_INSTALLED}"; then
      log "Skipping already installed Linux package: ${PACKAGE_NAME}"
      INSTALL_PACKAGE=0
      isError=0
    fi
  fi

  # Install only if required
  if [ "${INSTALL_PACKAGE}" == "1" ]; then
    # Install package
    LOG=$(DEBIAN_FRONTEND=noninteractive exec_force dpkg --install "${LINUX_PACKAGE}" 2>&1)
    isError=$?

    if [ "${isError}" != "0" ]; then
      log "Failure to install Linux package: ${LINUX_PACKAGE}"
      log "${LOG}" "\t"
    fi
  fi

  # Remount rootfs to read-only if needed
  if [ "${IS_ROOTFS_REMOUNTED_RW}" == "1" ]; then
    remount_rootfs_ro
  fi

  return ${isError}
}


#
# set_rootfs(string rootfsName)
# Set the rootfs name that shall use the function install_file / install_all_files.
# For example, if you have more than one rootfs because you have more than one version of a binary, you must use this function.
# WARNING: This function will die in case the rootfs specified is not found.
# Return code: 0 on success
#   Eg: set_rootfs                    (Will set default rootfs: rootfs)
#   Eg: set_rootfs rootfs             (Will set default rootfs: rootfs)
#   Eg: set_rootfs rootfs-2.0.10      (Will set another rootfs: rootfs-2.0.10)
#
set_rootfs(){
  local ROOTFS="$1"

  if [ "${ROOTFS}" != "" ]; then
    PACKAGE_ROOTFS="${ROOTFS}"
  else
    PACKAGE_ROOTFS="${DEFAULT_PACKAGE_ROOTFS}"
  fi

  # Remove trailing /
  PACKAGE_ROOTFS="$(echo "${PACKAGE_ROOTFS}" | tr -d \/)"

  if ! test -d "${PACKAGE_ROOTFS}"; then
    die "set_rootfs(): The rootfs specified does not exist: ${PACKAGE_ROOTFS}"
  fi

  return 0
}


#
# exec_silent(string cmd_line)
# Execute the specified command, but output nothing (info or error)
# However, you will be able to get the result of the command with the exported variable 'EXEC_SILENT_RES'.
# For example: echo ${EXEC_SILENT_RES}
# If you also want to force the execution of the command, use: exec_force exec_silent [cmd_line]
# Return code: the exit code of the command
#   Eg: exec_silent /doremi/etc/init.d/streamer stop
#
exec_silent(){
  local CMD="$*"
  local returnCode=0

  EXEC_SILENT_RES=$(${CMD} 2>&1)
  returnCode=$?

  export EXEC_SILENT_RES

  return ${returnCode}
}


#
# is_file_empty(string path_file, boolean ignore_spaces)
# Check if the specified file is empty. You can ignore all white spaces.
# Return code: 0 if the file is empty
# Return code: 1 if the file contains some date, if the file does not exist, if it cannot be read
#   Eg: is_file_empty /doremi/log/odeticsd.log 0    (Will check if the file is empty)
#   Eg: is_file_empty /doremi/log/odeticsd.log 1    (Will check if the file is empty, ignoring white spaces)
#
is_file_empty(){
  local FILE="$1"
  local IGNORE_SPACE="$2"
  local NB_CHAR_IN_FILE=0

  if ! test -r "${FILE}"; then
    log "is_file_empty(): Unable to check the file '${FILE}' (file does not exist or cannot be open)"
    return 1
  fi

  if [ "${IGNORE_SPACE}" == "1" ]; then
    NB_CHAR_IN_FILE=$(cat "${FILE}" | tr -d '[:space:]' | wc -c)
  else
    NB_CHAR_IN_FILE=$(cat "${FILE}" | wc -c)
  fi

  if [ "${NB_CHAR_IN_FILE}" -ge 1 ]; then
    return 1
  fi

  return 0
}


#
# flush_buffers()
# Force a flush of the file system buffers
# Return code: always 0
#
flush_buffers(){
  sync

  if test -w /proc/sys/vm/drop_caches; then
    echo 3 > /proc/sys/vm/drop_caches 2> /dev/null
  fi

  return 0
}


#
# extract_archive(string path_archive, string path_output, boolean die_on_failure)
# extract_archive(string path_archive, string path_output, boolean die_on_failure, string file_to_extract)
# Extract the given archive at the given output.
# This function will die on failure.
# By default, extract all files of the archive, but you can specify ONE specific file_to_extract
# Return code: 0 on success
# Return code: 1 or more on failure
#   Eg: extract_archive /tmp/my_archive.pkg /tmp/extract 1                       (Will extract all files my_archive.pkg in /tmp/extract and die on failure)
#   Eg: extract_archive /tmp/my_archive.pkg /tmp/extract 0 ./my_dir/my_file.txt  (Will extract my_dir/my_file.txt inside the archive my_archive.pkg in /tmp/extract)
#   Eg: extract_archive /tmp/my_archive.pkg /tmp/extract 0 my_file.txt           (Will extract ALL files my_file.txt inside the archive my_archive.pkg in /tmp/extract)
#   Eg: extract_archive /tmp/my_archive.pkg /tmp/extract 0 *.enc                 (Will extract ALL files .enc inside the archive my_archive.pkg in /tmp/extract)
#
extract_archive() {
  local PATH_ARCHIVE=$(get_absolute_path "$1")
  local PATH_OUPUT="$2"
  local DIE_ON_FAILURE="$3"
  local FILES_TO_EXTRACT="$4"
  local PKG_TYPE=""
  local PWD_OLD=$(pwd)
  local MSG=""
  local isError=0

  # Sanity checks
  if ! test -r "${PATH_ARCHIVE}"; then
    MSG="extract_archive(): archive does not exist or cannot be read (${PATH_ARCHIVE})"
    isError=1
  elif ! mkdir -p "${PATH_OUPUT}" &> /dev/null; then
    MSG="extract_archive(): cannot create output directory (${PATH_OUPUT})"
    isError=1
  fi

  if [ "${isError}" == 0 ]; then
    # Get archive type
    PKG_TYPE=$(get_archive_type "${PATH_ARCHIVE}")

    # Process archive
    if [ "${PKG_TYPE}" == "${ARCHIVE_TARGZ}" ]; then
      if ! cd "${PATH_OUPUT}" &> /dev/null; then
        MSG="extract_archive(): failed to change directory to ${PATH_OUPUT}"
        isError=1
      elif test "${FILES_TO_EXTRACT}" != "" && ! tar --wildcards --no-anchored -tzf "${PATH_ARCHIVE}" "${FILES_TO_EXTRACT}" &> /dev/null; then
         MSG="extract_archive(): archive does not contain any file '${FILES_TO_EXTRACT}'"
         isError=1
      elif ! tar --wildcards --no-anchored -zxf "${PATH_ARCHIVE}" "${FILES_TO_EXTRACT}" &> /dev/null; then
        MSG="extract_archive(): failed to extract archive with specified file (reported by tar)"
        isError=1
      fi

      # Go back to previous path
      cd "${PWD_OLD}" &> /dev/null
    else
      # For now, we support only tar GZ archives...
      MSG="extract_archive(): unsupported archive type (${PKG_TYPE})"
      isError=1
    fi
  fi

  if [ "${isError}" != 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "${MSG}"
    else
      log "${MSG} (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# check_dlms_for_package(string path_package, boolean die_on_failure)
# check_dlms_for_package(string path_package, boolean die_on_failure, string path_sbcsetup)
# Check if the given package has all required DLMs.
# This function will basically extract all encrypted binaries and use sbcsetup to check if all DLMs are OK.
# You can specify to use an sbcsetup binary through the optional argument. Else, sbcsetup of the system will be used.
# WARNING: This function only works for TAR GZ packages
# Return code: 0 on success
# Return code: 1 or more on failure
#   Eg: check_dlms_for_package /tmp/my_package.pkg 1                     (check that all DLMs are OK for the package and die on failure)
#   Eg: check_dlms_for_package /tmp/my_package.pkg 0 /tmp/sbcsetup.out   (check all DLMs are OK using a custom sbcsetup and do NOT die on failure)
#
check_dlms_for_package() {
  local PATH_PACKAGE="$1"
  local DIE_ON_FAILURE="$2"
  local FILE_SBCSETUP="$3"
  local FILE_SBCSETUP_SYSTEM="/doremi/sbin/sbcsetup.out"
  local PATH_TMP="/tmp/$$_$(date +%s)"
  local MSG=""
  local isError=0
  local nbSleep=0

  # Optional arg
  if [ "${FILE_SBCSETUP}" == "" ]; then
    FILE_SBCSETUP="${FILE_SBCSETUP_SYSTEM}"
  fi

  # Sanity check
  if ! test -x "${FILE_SBCSETUP}"; then
    MSG="check_dlms_for_package(): sbcsetup is missing or cannot be executed (${FILE_SBCSETUP})"
    isError=1
  elif ! test -r "${PATH_PACKAGE}"; then
    MSG="check_dlms_for_package(): archive is missing or cannot be read (${PATH_PACKAGE})"
    isError=1
  elif [ "$(get_archive_type)" != "${ARCHIVE_TARGZ}" ]; then
    MSG="check_dlms_for_package(): only supports TAR GZ archives"
    isError=1
  fi

  # Extract package in temp folder (only encrypted binaries)
  if ! extract_archive "${PATH_PACKAGE}" "${PATH_TMP}" 0 "*.enc"; then
    MSG="check_dlms_for_package(): unable to extract the package"
    isError=1
  fi

  # In case the Security Manager is not yet detected, wait 10s (workaround)
  if ! get_path_dolphin0 &> /dev/null; then
    print_msg "Waiting for Security Manager"
    sleep 10

    if get_path_dolphin0 &> /dev/null; then
      print_success
    else
      die "Security Manager is not detected"
    fi
  fi

  # Process all encrypted binaries
  for enc in $(find "${PATH_TMP}" -type f); do
    ${FILE_SBCSETUP} -f --prepare "${enc}" &> /dev/null
    isError=$?
    if [ ${isError} != 0 ]; then
      enc=$(echo "${enc}" | sed -u -e "s|^${PATH_TMP}||g")
      MSG="DLMs requirement not met for binary: ${enc}"
      break
    fi
  done

  # Cleanup
  rm -fr "${PATH_TMP}" &> /dev/null

  if [ "${isError}" != 0 ]; then
    if [ "${DIE_ON_FAILURE}" == "1" ]; then
      die "${MSG}"
    else
      log "${MSG} (ignoring failure)"
    fi
  fi

  return ${isError}
}


#
# get_absolute_path(string relative_path)
# Return the absolute path of a relative path using command readlink
# Return code: 0 on success
# Return code: 1 on failure
#   Eg: get_absolute_path ./tmp/myfile    (Will return: /home/user1/tmp/myfile)
#
get_absolute_path() {
  local PATH_RELAT="$1"
  local PATH_ABS=""

  if ! PATH_ABS=$(readlink -f "${PATH_RELAT}" 2> /dev/null); then
    PATH_ABS=""
    return 1
  fi

  echo "${PATH_ABS}"

  return 0
}


#
# install_bundle_information(int BUNDLE_STATE)
# install_bundle_information(int BUNDLE_STATE, string bundle_info)
# Install all bundle information on the unit, when a bundle is installed or uninstalled (even partially)
# WARNING: Do not forget to define the following variables: BUNDLE_NAME + BUNDLE_VERSION
#   - BUNDLE_STATE: one of the possible values:
#     - BUNDLE_STATE_UNKNOWN
#     - BUNDLE_STATE_INSTALLED
#     - BUNDLE_STATE_INSTALLED_PARTIAL
#     - BUNDLE_STATE_UNINSTALLED
#     - BUNDLE_STATE_UNINSTALLED_PARTIAL
#   - bundle_info: OPTIONAL: more information about the install or uninstall of the bundle.
# Return code: always 0, will die on failure
#   Eg: install_bundle_information BUNDLE_STATE_INSTALLED
#   Eg: install_bundle_information BUNDLE_STATE_INSTALLED_PARTIAL "failed due to error"
#
install_bundle_information(){
  local BUNDLE_STATE="$1"
  local BUNDLE_INFO="$2"
  local BUNDLE_STATE_HUMAN=""
  local BUNDLE_NAME="${BUNDLE_NAME}"		# Global variable: must be defined by user
  local BUNDLE_VERSION="${BUNDLE_VERSION}"	# Global variable: must be defined by user
  local BUNDLE_DATE_S=$(date +%s)
  local BUNDLE_DATE=$(date)
  local BUNDLE_INFO_FULL_PATH="${BUNDLE_INFO_PATH}/${BUNDLE_NAME}"

  # First operation is to install the bundle version compatibility file, when a bundle is installed
  install_bundle_versions_compatibility

  # To be compatible with PPC /bin/sh interpreter, use following syntax to fetch
  # the value of the variable name stored in BUNDLE_STATE
  BUNDLE_STATE="$(eval echo \$${BUNDLE_STATE})"

  # Sanity check
  if   [ "${BUNDLE_NAME}" == "" ]; then
    die "Variable BUNDLE_NAME is NOT defined or is empty"
  elif [ "${BUNDLE_VERSION}" == "" ]; then
    die "Variable BUNDLE_VERSION is NOT defined or is empty"
  elif ! mkdir -p "${BUNDLE_INFO_FULL_PATH}" &> /dev/null; then
    die "Failed to create bundle information directory (${BUNDLE_INFO_FULL_PATH})"
  fi

  # Process bundle state
  if   [ "${BUNDLE_STATE}" == "${BUNDLE_STATE_UNKNOWN}" ]; then
    BUNDLE_STATE_HUMAN="unknown"
  elif [ "${BUNDLE_STATE}" == "${BUNDLE_STATE_INSTALLED}" ]; then
    BUNDLE_STATE_HUMAN="installed"
  elif [ "${BUNDLE_STATE}" == "${BUNDLE_STATE_INSTALLED_PARTIAL}" ]; then
    BUNDLE_STATE_HUMAN="partially installed"
  elif [ "${BUNDLE_STATE}" == "${BUNDLE_STATE_UNINSTALLED}" ]; then
    BUNDLE_STATE_HUMAN="uninstalled"
  elif [ "${BUNDLE_STATE}" == "${BUNDLE_STATE_UNINSTALLED_PARTIAL}" ]; then
    BUNDLE_STATE_HUMAN="partially uninstalled"
  else
    die "The option 'BUNDLE_STATE' is invalid (BUNDLE_STATE: ${BUNDLE_STATE})"
  fi

  # Write information in files
  echo "${BUNDLE_STATE}"	> "${BUNDLE_INFO_FULL_PATH}/state"
  echo "${BUNDLE_INFO}"		> "${BUNDLE_INFO_FULL_PATH}/info"
  echo "${BUNDLE_STATE_HUMAN}"	> "${BUNDLE_INFO_FULL_PATH}/state_name"
  echo "${BUNDLE_NAME}"		> "${BUNDLE_INFO_FULL_PATH}/name"
  echo "${BUNDLE_VERSION}"	> "${BUNDLE_INFO_FULL_PATH}/version"
  echo "${BUNDLE_DATE_S}"	> "${BUNDLE_INFO_FULL_PATH}/timestamp"
  echo "${BUNDLE_DATE}"		> "${BUNDLE_INFO_FULL_PATH}/date"

  return 0
}


#
# install_bundle_version()
# Install the bundle version info in /doremi/etc/
# This function must be called ONLY if the bundle has been successfully installed
# WARNING: Do not forget to define the following variables: BUNDLE_NAME + BUNDLE_VERSION
# Return code: always 0 (will die on failure)
#   Eg: install_bundle_version     (install the bundle version and name in /doremi/etc/)
#
install_bundle_version(){
  local BUNDLE_NAME="${BUNDLE_NAME}"            # Global variable: must be defined by user
  local BUNDLE_VERSION="${BUNDLE_VERSION}"      # Global variable: must be defined by user

  # Sanity check
  if   [ "${BUNDLE_NAME}" == "" ]; then
    die "Variable BUNDLE_NAME is NOT defined or is empty"
  elif [ "${BUNDLE_VERSION}" == "" ]; then
    die "Variable BUNDLE_VERSION is NOT defined or is empty"
  fi

  # Write information in files
  echo "${BUNDLE_VERSION}"	> "${BUNDLE_VERSION_FILE}"
  echo "${BUNDLE_NAME}"		> "${BUNDLE_NAME_FILE}"

  # Sanity check
  if   [ "$(cat "${BUNDLE_VERSION_FILE}" 2> /dev/null)" != "${BUNDLE_VERSION}" ]; then
    die "Bundle version was not properly set in ${BUNDLE_VERSION_FILE}"
  elif [ "$(cat "${BUNDLE_NAME_FILE}" 2> /dev/null)" != "${BUNDLE_NAME}" ]; then
    die "Bundle name was not properly set in ${BUNDLE_NAME_FILE}"
  fi

  return 0
}


#
# get_partition_space_usage(string partition_path, string KIND)
# get_partition_space_usage(string partition_path, string KIND, boolean display_human)
# Return the space usage information about a partition.
# partition_path: the path of the partition, for example: /doremi/log, /var, /data, etc...
# KIND: the value you want to get, one of the value:
#    - SIZE (the total size of the partition)
#    - USED (the used space of the partition)
#    - FREE (the available space of the partition)
#    - USED_PERCENT (the used space in % of the partition)
# display_human: optional, if sets to true, return usage as human readable (ie: 695M instead). If sets to false (default), return value in KB (ie: 711508)
# Return code: 0 in case of success
# Return code: 1 on error
#   Eg: get_partition_space_usage /doremi SIZE        (return the total size of /doremi in KB, ie: 711508)
#   Eg: get_partition_space_usage /doremi SIZE 1      (return the total size of /doremi in human readable, ie: 695M)
#   Eg: get_partition_space_usage /data USED_PERCENT  (return the usage in percent of /data, ie: 32)
#
get_partition_space_usage(){
  local PARTITION="$1"
  local KIND="$2"
  local HUMAN_READ="$3"
  local OPTION=""
  local DF_OUTPUT=""

  if [ "${HUMAN_READ}" == "1" ]; then
    OPTION="-h"
  else
    OPTION=""
  fi

  if ! DF_OUTPUT=$(df ${OPTION} "${PARTITION}" 2> /dev/null); then
    return 1
  fi

  # Do not get the header of the response
  DF_OUTPUT=$(echo "${DF_OUTPUT}" | tail -1)

  if   [ "${KIND}" == "SIZE" ]; then
    echo "${DF_OUTPUT}" | awk '{print $2}'
  elif [ "${KIND}" == "USED" ]; then
    echo "${DF_OUTPUT}" | awk '{print $3}'
  elif [ "${KIND}" == "FREE" ]; then
    echo "${DF_OUTPUT}" | awk '{print $4}'
  elif [ "${KIND}" == "USED_PERCENT" ]; then
    echo "${DF_OUTPUT}" | awk '{print $5}' | tr -d '%'
  else
    return 1
  fi

  return 0
}


#
# is_in_rescue()
# is_in_rescue(string what_to_check)
# This function will check if the system is running in rescue environment or not.
# Depending on the arguments provided, you can choose to check only the firmware, only the Security Manager or at least one of them.
# Argument what_to_check: value allowed are: "fw" (to check the firmware rescue), "sm" (to check the Security Manager rescue)
# WARNING: This function will DIE if the argument provided is not the expected one.
# Return code: 0 in case the system is running rescue
# Return code: 1 if the system is NOT running in rescue
# Return code: 2 if we are unable to retrieve the state
#    Eg: is_in_rescue               (check if the Security Manager OR the firmware is in rescue)
#    Eg: is_in_rescue "fw"          (check if the Firmware is in rescue, whatever the Security Manager)
#    Eg: is_in_rescue "sm"          (check if the Security Manager is in rescue, whatever the Firmware)
#
is_in_rescue(){
  local WHAT_TO_CHECK="$1"
  local FILE_SBCSETUP_SYSTEM="/doremi/sbin/sbcsetup.out"
  local RESCUE_STATE=""
  local isFWRescue=0
  local isSMRescue=0
  local isRescue=0

  # Get the rescue state
  if ! test -x ${FILE_SBCSETUP_SYSTEM}; then
    return 2
  elif ! RESCUE_STATE=$(${FILE_SBCSETUP_SYSTEM} --get-version 2>&1); then
    return 2
  fi

  # Check the rescue state
  if ! echo "${RESCUE_STATE}" | grep -q "dolphin is running normal environment"; then
    isFWRescue=1
  fi
  if ! echo "${RESCUE_STATE}" | grep -q "sbc405 is running normal environment"; then
    isSMRescue=1
  fi

  # Check the rescue state
  if [ "${WHAT_TO_CHECK}" == "" ]; then
    if [ "${isFWRescue}" == "1" ] || [ "${isSMRescue}" == "1" ]; then
      isRescue=1
    fi
  elif [ "${WHAT_TO_CHECK}" == "fw" ]; then
    isRescue="${isFWRescue}"
  elif [ "${WHAT_TO_CHECK}" == "sm" ]; then
    isRescue="${isSMRescue}"
  else
    die "Unsupported argument '${WHAT_TO_CHECK}' for function is_in_rescue()"
  fi

  if [ "${isRescue}" == "1" ]; then
    return 0
  else
    return 1
  fi
}

#
# install_bundle_versions_compatibility()
# Install the bundle versions compatibility file into /doremi/etc/
# This function is automatically called by function 'install_bundle_information()' when a bundle is installed, to install its list of Software and Firmware supposed to be run by the unit.
# Then, the software uses this file to trigger an alert on the system if the versions being run differs from the ones defined in the file.
# WARNING: this function only works if the file bundle_versions_compatibility.txt is present in the package root directory
# Return code: 0 if the file has been installed or not present in the package
# Return code: other in case of error
#   Eg: install_bundle_versions_compatibility     (install the bundle versions compatibility on the system)
#
install_bundle_versions_compatibility(){
  local FILE_PKG_BUNDLE_VER_COMP="./bundle_versions_compatibility.txt"
  local LOG=""

  if ! test -e "${FILE_PKG_BUNDLE_VER_COMP}"; then
    return 0
  fi

  if ! LOG=$(install -m 0644 -o root -g admin "${FILE_PKG_BUNDLE_VER_COMP}" "${FILE_BUNDLE_VER_COMP}" 2>&1); then
    log "WARNING: Failure to install bundle versions compatibility file. Error reported was:"
    log "${LOG}" "\t"
    return 1
  fi

  return 0
}


#
# Wrappers
#

sed(){
  local PLATFORM=$(get_platform_type)

  # s430-10 PPC sed does not support -u option
  if [ "${PLATFORM}" != "${PLATFORM_S430_10}" ]; then
    /bin/sed -u "$@"
  else
    /bin/sed "$@"
  fi

  return $?
}

#
# Main
#
if [ "$1" == "--show-functions" ]; then
  declare -f -F | sed -e "s/^declare -f //g"
elif [ "$1" == "--show-functions-debug" ]; then
  declare -f
fi
